/**
 * 
 */
package CloneTransforming;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

/**
 * @author hoan
 *
 */
public class CloneReportFixer {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String dataDir = ".";
		String projectName = "argouml";
		String inconsistenciesDir = dataDir + "\\" + projectName + "_30_locations_1000_2000\\inconsistencies";
		//fixReportHeader(new File(inconsistenciesDir));
		//fixReportExtension(new File(inconsistenciesDir));
		addInfoFile(new File(inconsistenciesDir));
	}
	
	private static void addInfoFile(File file)
	{
		if(file.isDirectory())
		{
			if(Character.isDigit(file.getName().charAt(0)) && file.getName().contains("_"))
			{
				try {
					BufferedWriter out = new BufferedWriter(new FileWriter(file.getAbsolutePath() + "\\info.txt"));
					out.write("#Change = 1 | 2 ( 1 side or 2 side)\r\n");
					out.write("#Inconsistent = No | {S, N, L} (No or any combination of structure, naming and label\r\n");
					out.write("#Sync = 2T | 2F | 1T | 1F (1 | 2 side and cortect | incorrect)\r\n\r\n");
					out.write("Change: \r\n");
					out.write("Inconsistent: \r\n");
					out.write("Sync: \r\n");
					out.write("Locations: \r\n");
					out.write("Correct: \r\n");
					out.write("Miss: \r\n");
					out.write("Comment:");
					out.flush();
					out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			else
				for (File sub : file.listFiles())
					addInfoFile(sub);
		}
	}
	
	private static void fixReportExtension(File file)
	{
		if(file.isDirectory())
			for (File sub : file.listFiles())
				fixReportExtension(sub);
		else if(file.getName().endsWith(".txt"))
		{
			String name = file.getAbsolutePath();
			name = name.substring(0, name.length()-3) + "java";
			file.renameTo(new File(name));
		}
	}
	private static void fixReportHeader(File file)
	{
		if(file.isDirectory())
			for (File sub : file.listFiles())
				fixReportHeader(sub);
		else
		{
			StringBuffer buf = new StringBuffer();
			try {
				boolean formatted = false;
				BufferedReader in = new BufferedReader(new FileReader(file));
				for(int i = 0; i < 3; i++)
					buf.append(in.readLine() + "\n");
				String line = in.readLine();
				if(line.isEmpty())
				{
					formatted = true;
				}
				else
				{
					buf.append("\n");
					buf.append(line + "\n");
					while((line = in.readLine()) != null)
						buf.append(line + "\n");
				}
				in.close();
				if(!formatted)
				{
					BufferedWriter out = new BufferedWriter(new FileWriter(file));
					out.write(buf.toString());
					out.flush();
					out.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
