/**
 * 
 */
package CloneTransforming;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

import org.eclipse.jdt.core.dom.ASTNode;

import cleman.Main;
import cleman.Util;

/**
 * @author Hoan Nguyen
 *
 */
public class CloneSync {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String dataDir = ".";
		String projectName = "eu.geclipse";
		String inconsistenciesDir = dataDir + "\\" + projectName + "_30_locations\\inconsistencies";
		ArrayList<Integer> fixRevs = getFixRevisions(dataDir + "\\" + projectName + "_fix_bug_revisions.txt");
		ArrayList<Integer> cloneRevs = getCloneRevisions(inconsistenciesDir);
		if (fixRevs != null)
			cloneRevs.retainAll(fixRevs);
		Collections.sort(cloneRevs);
		System.out.println(projectName);
		for(int rev : cloneRevs)
		{
			System.out.println("\t" + rev);
			File dir = new File(inconsistenciesDir + "\\" + rev);
			for(File sub : dir.listFiles())
			{
				System.out.println("\t\t" + sub.getName());
				String[] pair = sub.getName().split("_");
				//System.out.println("\t\t\t" + pair[0] + "_old.txt");
				ASTNode ast1M = ASTNodeWrapper.createAST(getFileContent(new File(sub.getAbsolutePath() + "\\" + pair[0] + "_old.java"))[1]);
				//System.out.println("\t\t\t" + pair[0] + "_new.txt");
				ASTNode ast1N = ASTNodeWrapper.createAST(getFileContent(new File(sub.getAbsolutePath() + "\\" + pair[0] + "_new.java"))[1]);
				//System.out.println("\t\t\t" + pair[1] + "_old.txt");
				ASTNode ast2M = ASTNodeWrapper.createAST(getFileContent(new File(sub.getAbsolutePath() + "\\" + pair[1] + "_old.java"))[1]);
				//System.out.println("\t\t\t" + pair[1] + "_new.txt");
				ASTNode ast2N = ASTNodeWrapper.createAST(getFileContent(new File(sub.getAbsolutePath() + "\\" + pair[1] + "_new.java"))[1]);
				CloneMapper cloneMapper = new CloneMapper(ast1M, ast2M, ast1N, ast2N);
				cloneMapper.mapNaming();
				cloneMapper.synchronize();
				String sync = ASTNodeWrapper.getContent(cloneMapper.astSync12);
				//System.out.println(sync);
				try {
					PrintStream out = new PrintStream(new FileOutputStream(sub.getAbsolutePath() + "\\" + sub.getName() + ".java"));
					out.print(sync);
					out.flush();
					out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	public static ArrayList<Integer> getCloneRevisions(String path)
	{
		ArrayList<Integer> revs = new ArrayList<Integer>();
		File dir = new File(path);
		for (File sub : dir.listFiles())
			if(sub.isDirectory())
			{
				if (Character.isDigit(sub.getName().charAt(0)))
					revs.add(Integer.parseInt(sub.getName()));
			}
		
		return revs;
	}
	
	public static String[] getFileContent(File file)
	{
		String[] contents = new String[]{"", ""};
		StringBuffer strBuf = new StringBuffer();
		try {
			BufferedReader in = new BufferedReader(new FileReader(file));
	    	String line = "";
	    	for(int i = 0; i < 3; i++)
	    		strBuf.append(in.readLine() + "\n");
	    	contents[0] = strBuf.toString();
	    	in.readLine();
	    	strBuf = new StringBuffer();
	    	while ((line = in.readLine()) != null) { 
	    		strBuf.append(line + "\n");
	    	}
	    	in.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		contents[1] = strBuf.toString();
		return contents;
	}
	public static ArrayList<Integer> getFixRevisions(String path)
	{
		ArrayList<Integer> revs = new ArrayList<Integer>();
		try {
			Scanner scanner = new Scanner(new File(path));
			while (scanner.hasNextInt())
			{
				revs.add(scanner.nextInt());
			}
			scanner.close();
		} catch (FileNotFoundException e) {
			return null;
		}
		
		return revs;
	}
}
