/**
 * 
 */
package CloneTransforming;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;

import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.swt.*;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;

import treeMapping.LineDiff;
import treeMapping.MapSourceFile;
import treeMapping.MapVisitor;
import treeMapping.TreeMapper;

/**
 * @author hoan
 *
 */
public class FrmCloneSync extends Composite {
	private Menu menuBar, menuFile, menuView, menuHelp, menuInconsistencies;
	private MenuItem menuFileHeader, menuViewHeader, menuWrapText, menuShowInfo, menuSumarry, menuHelpHeader, menuExitItem, menuReloadItem, menuOpenItem, menuGetHelpItem;
	private MenuItem miView1, miViewLate, miView2, miViewT, miViewF, miViewInteresting, miInconsistencies, miSI, miNI, miLI;
	private Tree treeRevisions, treeChanges;
	private StyledText txtSrc1M, txtSrc2M, txtSrc1N, txtSrc2N;
	private Label label1M, label2M,label1N, label2N;
	private Color COLOR_ADD, COLOR_TXTHI, COLOR_DEL, COLOR_MOD_IN, COLOR_MOD_EX, COLOR_SELECT, COLOR_BLACK;
	private String cloneDataPath = "", systemName, fixRevisionFile;
	private ASTNode ast1M, ast2M, ast1N, ast2N, astSync12;
	private HashMap<ASTNode, ArrayList<ASTNode>> tree1M, tree2M, tree1N, tree2N, treeSync12;
	
	public FrmCloneSync(Composite parent,int style) {
		super(parent,style);
		this.COLOR_ADD = getDisplay().getSystemColor(SWT.COLOR_BLUE);
		this.COLOR_TXTHI = getDisplay().getSystemColor(SWT.COLOR_BLUE);
		this.COLOR_DEL = getDisplay().getSystemColor(SWT.COLOR_DARK_RED);
		this.COLOR_MOD_IN = getDisplay().getSystemColor(SWT.COLOR_MAGENTA);
		this.COLOR_MOD_EX = getDisplay().getSystemColor(SWT.COLOR_DARK_MAGENTA);
		this.COLOR_SELECT = getDisplay().getSystemColor(SWT.COLOR_GRAY);
		this.COLOR_BLACK = getDisplay().getSystemColor(SWT.COLOR_BLACK);
			
		menuBar = new Menu(getShell(), SWT.BAR);
		menuFileHeader = new MenuItem(menuBar, SWT.CASCADE);
	    menuFileHeader.setText("&File");
	    menuFile = new Menu(getShell(), SWT.DROP_DOWN);
	    menuFileHeader.setMenu(menuFile);
	    menuOpenItem = new MenuItem(menuFile, SWT.PUSH);
	    menuOpenItem.setText("&Open");
	    menuReloadItem = new MenuItem(menuFile, SWT.PUSH);
	    menuReloadItem.setText("&Reload");
	    menuExitItem = new MenuItem(menuFile, SWT.PUSH);
	    menuExitItem.setText("E&xit");
	    menuViewHeader = new MenuItem(menuBar, SWT.CASCADE);
	    menuViewHeader.setText("&View");
	    menuView = new Menu(getShell(), SWT.DROP_DOWN);
	    menuViewHeader.setMenu(menuView);
	    miView1 = new MenuItem(menuView, SWT.CHECK);
	    miView1.setText("1");
	    miViewLate = new MenuItem(menuView, SWT.CHECK);
	    miViewLate.setText("Late-sync");
	    miView2 = new MenuItem(menuView, SWT.CHECK);
	    miView2.setText("2");
	    miViewT = new MenuItem(menuView, SWT.CHECK);
	    miViewT.setText("True");
	    miViewF = new MenuItem(menuView, SWT.CHECK);
	    miViewF.setText("False");
	    miInconsistencies = new MenuItem(menuView, SWT.CASCADE);
	    miInconsistencies.setText("Inconsistencies");
	    menuInconsistencies = new Menu(getShell(), SWT.DROP_DOWN);
	    miInconsistencies.setMenu(menuInconsistencies);
	    miSI = new MenuItem(menuInconsistencies, SWT.CHECK);
	    miSI.setText("Structure");
	    miNI = new MenuItem(menuInconsistencies, SWT.CHECK);
	    miNI.setText("Name");
	    miLI = new MenuItem(menuInconsistencies, SWT.CHECK);
	    miLI.setText("Literal");
	    miViewInteresting = new MenuItem(menuView, SWT.CHECK);
	    miViewInteresting.setText("Interesting");
	    menuShowInfo = new MenuItem(menuBar, SWT.CHECK);
	    menuShowInfo.setText("Show &Info");
	    menuSumarry = new MenuItem(menuBar, SWT.CHECK);
	    menuSumarry.setText("Summary");
	    menuWrapText = new MenuItem(menuBar, SWT.CHECK);
	    menuWrapText.setText("&Wrap Text");
	    menuHelpHeader = new MenuItem(menuBar, SWT.CASCADE);
	    menuHelpHeader.setText("&Help");
	    menuHelp = new Menu(getShell(), SWT.DROP_DOWN);
	    menuHelpHeader.setMenu(menuHelp);
	    menuGetHelpItem = new MenuItem(menuHelp, SWT.PUSH);
	    menuGetHelpItem.setText("Help &Contents");
	    //menuGetHelpItem.setImage(new Image(getDisplay(), ICON_HELP));
	   resetMenus();
	   
	    menuOpenItem.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				DirectoryDialog dialog = new DirectoryDialog(getShell(),SWT.PRIMARY_MODAL | SWT.OPEN);
				dialog.setText("Clone Data Path");
				if (cloneDataPath.isEmpty())
				{
					File tmpFile = new File("");
					dialog.setFilterPath(tmpFile.getAbsolutePath());
				}
				else
					dialog.setFilterPath(cloneDataPath);
				String file = dialog.open(); 
				if (file == null) return; 
				getShell().setText("JSync: " + file);
				cloneDataPath = file;
				open(file);
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				DirectoryDialog dialog = new DirectoryDialog(getShell(),SWT.PRIMARY_MODAL | SWT.OPEN);
				dialog.setText("Clone Data Path");
				String file = dialog.open(); 
				if (file == null) return; 
				getShell().setText("JSync: " + file);
			}
		});
	    menuReloadItem.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open(cloneDataPath);
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    menuExitItem.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getShell().close();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				getShell().close();
			    //getDisplay().dispose();
			}
		});
	    menuWrapText.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				toggleTextWrap();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				toggleTextWrap();
			}
		});
	    menuShowInfo.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if (treeRevisions.getSelection() != null && treeRevisions.getSelection().length > 0)
				{
					TreeItem item = treeRevisions.getSelection()[0];
					String path = cloneDataPath + "\\inconsistencies\\";
					if(item.getParentItem() != null)
					{
						path += item.getParentItem().getText() + "\\";
						path += item.getText();
						try {
							Runtime.getRuntime().exec("notepad \"" + path + "\\info.txt\"");
						} catch (IOException ioe) {
							ioe.printStackTrace();
						}
					}
				}
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    menuSumarry.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if (cloneDataPath == "")
				{
					MessageBox mb = new MessageBox(getShell(), SWT.ICON_INFORMATION | SWT.OK);
					mb.setText("JSync - Summary");
					mb.setMessage("Please open a system!");
					mb.open();
				}
				else
				{
					CloneSystemSyncInfo info = new CloneSystemSyncInfo();
					info.readSyncInfo(cloneDataPath);
					Shell shell = new Shell(getDisplay());
					shell.setText("JSync - Summary");
					shell.setLayout(new FillLayout());
					FrmSummary frmSum = new FrmSummary(shell, SWT.NONE);
					frmSum.text.setText(info.print());
					frmSum.pack();
					shell.pack();
					shell.open();
				}
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miView1.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miViewLate.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miView2.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miViewT.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miViewF.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miSI.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miNI.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miLI.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    miViewInteresting.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				open();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		});
	    
	    parent.getShell().setMenuBar(menuBar);
	    
		GridLayout gridLayout = new GridLayout();
		super.setLayout(gridLayout);
		
		SashForm frmPrimary = new SashForm(this, SWT.HORIZONTAL);
		frmPrimary.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL | 
				GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		SashForm frmPrimLeft = new SashForm(frmPrimary, SWT.NONE);
		frmPrimLeft.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL | 
				GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		TabFolder tabFolder = new TabFolder(frmPrimLeft, SWT.BORDER);
		TabItem tabRevisions = new TabItem(tabFolder, SWT.NONE);
		tabRevisions.setText("Revisions");
		treeRevisions = new Tree(tabFolder, SWT.BORDER | SWT.SINGLE | SWT.V_SCROLL | SWT.H_SCROLL | SWT.FULL_SELECTION);
		treeRevisions.setLayoutData(new GridData(GridData.GRAB_VERTICAL | GridData.VERTICAL_ALIGN_FILL));
		tabRevisions.setControl(treeRevisions);
		TabItem tabChanges = new TabItem(tabFolder, SWT.NONE);
		tabChanges.setText("Changes");
		treeChanges = new Tree(tabFolder, SWT.BORDER | SWT.SINGLE | SWT.V_SCROLL | SWT.H_SCROLL | SWT.FULL_SELECTION);
		treeChanges.setLayoutData(new GridData(GridData.GRAB_VERTICAL | GridData.VERTICAL_ALIGN_FILL));
		tabChanges.setControl(treeChanges);
		treeRevisions.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				for(TreeItem item : treeRevisions.getSelection())
				{
					if(item.getParentItem() != null)
					{
						String path = cloneDataPath + "\\inconsistencies\\";
						path += item.getParentItem().getText() + "\\" + item.getText();
						setSource(path);
					}
				}
			}
		});
		treeRevisions.addMouseListener(new MouseListener() {
			@Override
			public void mouseUp(MouseEvent e) {
				// TODO Auto-generated method stub
			}
			@Override
			public void mouseDown(MouseEvent e) {
				// TODO Auto-generated method stub
			}
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				// TODO Auto-generated method stub
				TreeItem item = treeRevisions.getSelection()[0];
				String path = cloneDataPath + "\\inconsistencies\\";
				if(item.getParentItem() != null)
				{
					path += item.getParentItem().getText() + "\\";
				}
				path += item.getText();
				try {
					Runtime.getRuntime().exec("explorer \"" + path + "\"");
				} catch (IOException ioe) {
					ioe.printStackTrace();
				}
			}
		});
		
		SashForm frmPrimRight = new SashForm(frmPrimary, SWT.VERTICAL);
		frmPrimRight.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL | 
				GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		SashForm frmSubHorizontal1 = new SashForm(frmPrimRight, SWT.HORIZONTAL);
		frmSubHorizontal1.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL | 
				GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		Composite composite = new Composite(frmSubHorizontal1, SWT.NONE);
		composite.setLayout(new GridLayout());
		composite.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		label1M = new Label(composite, SWT.NONE);
		label1M.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING | GridData.FILL_HORIZONTAL));
		label1M.setText("\n\n\n");
		txtSrc1M = new StyledText(composite, SWT.BORDER | SWT.READ_ONLY | SWT.H_SCROLL | SWT.V_SCROLL);
		txtSrc1M.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL 
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		composite = new Composite(frmSubHorizontal1, SWT.NONE);
		composite.setLayout(new GridLayout());
		composite.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		Button btnClone = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnClone.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.VERTICAL_ALIGN_CENTER));
		btnClone.setText("Clone");
		Button btnShowClone = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnShowClone.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.VERTICAL_ALIGN_CENTER));
		btnShowClone.setText("Show");
		Button btnClearClone = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnClearClone.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.VERTICAL_ALIGN_CENTER));
		btnClearClone.setText("Clear");
		composite = new Composite(frmSubHorizontal1, SWT.NONE);
		composite.setLayout(new GridLayout());
		composite.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		label2M = new Label(composite, SWT.NONE);
		label2M.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING | GridData.FILL_HORIZONTAL));
		label2M.setText("\n\n\n");
		txtSrc2M = new StyledText(composite, SWT.BORDER | SWT.READ_ONLY | SWT.H_SCROLL | SWT.V_SCROLL);
		txtSrc2M.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL 
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		frmSubHorizontal1.setWeights(new int[]{48, 4 , 48});
		
		SashForm frmSubHorizontal2 = new SashForm(frmPrimRight, SWT.HORIZONTAL);
		frmSubHorizontal2.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL | 
				GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		composite = new Composite(frmSubHorizontal2, SWT.NONE);
		gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		composite.setLayout(gridLayout);
		composite.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		Button btnDiff1 = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnDiff1.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.GRAB_HORIZONTAL));
		btnDiff1.setText("Diff");
		Button btnShowDiff1 = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnShowDiff1.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.GRAB_HORIZONTAL));
		btnShowDiff1.setText("Show");
		Button btnClearDiff1 = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnClearDiff1.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.GRAB_HORIZONTAL));
		btnClearDiff1.setText("Clear");
		composite = new Composite(frmSubHorizontal2, SWT.NONE);
		composite.setLayout(new GridLayout());
		composite.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		composite = new Composite(frmSubHorizontal2, SWT.NONE);
		gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		composite.setLayout(gridLayout);
		composite.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		Button btnDiff2 = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnDiff2.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.GRAB_HORIZONTAL));
		btnDiff2.setText("Diff");
		Button btnShowDiff2 = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnShowDiff2.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.GRAB_HORIZONTAL));
		btnShowDiff2.setText("Show");
		Button btnClearDiff2 = new Button(composite, SWT.PUSH | SWT.CENTER);
		btnClearDiff2.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.GRAB_HORIZONTAL));
		btnClearDiff2.setText("Clear");
		frmSubHorizontal2.setWeights(new int[]{48, 4 , 48});
		
		SashForm frmSubHorizontal3 = new SashForm(frmPrimRight, SWT.HORIZONTAL);
		frmSubHorizontal3.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL | 
				GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		composite = new Composite(frmSubHorizontal3, SWT.NONE);
		composite.setLayout(new GridLayout());
		composite.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		label1N = new Label(composite, SWT.NONE);
		label1N.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING | GridData.FILL_HORIZONTAL));
		label1N.setText("\n\n\n");
		txtSrc1N = new StyledText(composite, SWT.BORDER | SWT.READ_ONLY | SWT.H_SCROLL | SWT.V_SCROLL);
		txtSrc1N.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL 
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		composite = new Composite(frmSubHorizontal3, SWT.NONE);
		gridLayout = new GridLayout();
		composite.setLayout(gridLayout);
		composite.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		Button btnSync = new Button(composite, SWT.PUSH);
		btnSync.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.VERTICAL_ALIGN_CENTER));
		btnSync.setText("Sync");
		composite = new Composite(frmSubHorizontal3, SWT.NONE);
		composite.setLayout(new GridLayout());
		composite.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.VERTICAL_ALIGN_CENTER | GridData.HORIZONTAL_ALIGN_CENTER));
		label2N = new Label(composite, SWT.NONE);
		label2N.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING | GridData.FILL_HORIZONTAL));
		label2N.setText("\n\n\n");
		txtSrc2N = new StyledText(composite, SWT.BORDER | SWT.READ_ONLY | SWT.H_SCROLL | SWT.V_SCROLL);
		txtSrc2N.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL 
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		frmSubHorizontal3.setWeights(new int[]{48, 4 , 48});
		
		frmPrimRight.setWeights(new int[]{48, 4, 48});
		frmPrimary.setWeights(new int[]{10, 90});
		
		btnClone.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						//resetTexts();
						if(ast1M != null && ast2M != null)
						{
							setClonedText(txtSrc1M, tree1M, ast1M);
							setClonedText(txtSrc2M, tree2M, ast2M);
						}
					}
				});
			}
		});
		btnShowClone.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						if(ast1M == null || ast2M == null)
							return;
						MapSourceFile file1M = new MapSourceFile(ast1M.toString());
						MapSourceFile file2M = new MapSourceFile(ast2M.toString());
						file1M.buildBlockCommentLines();
						file2M.buildBlockCommentLines();
						
						LineDiff lineDiff = new LineDiff(file1M, file2M);
						ArrayList<ArrayList<Integer>> diff = lineDiff.doDiffO();
						file1M.setUnchangedLines(diff.get(0));
						file2M.setUnchangedLines(diff.get(1));
						TreeMapper mapper = new TreeMapper(file1M, file2M);
						mapper.map();
						
						Shell shell = new Shell(getDisplay());
						shell.setText("Clone Mapping");
						shell.setLayout(new FillLayout());
									
						FrmDiff frmDiff = new FrmDiff(shell, SWT.NONE);
						frmDiff.txtSrc1.setText(file1M.getFileContent());
						frmDiff.txtSrc2.setText(file2M.getFileContent());
						setDiffedText(frmDiff.txtSrc1, file1M.getTree(), file1M.getAst());
						setDiffedText(frmDiff.txtSrc2, file2M.getTree(), file2M.getAst());
						final Point minimum = shell.computeSize(SWT.DEFAULT,SWT.DEFAULT,true);
						shell.addControlListener(new ControlAdapter() {
							public void controlResized(ControlEvent e) {
								Shell shell = (Shell)e.widget;
								Point size = shell.getSize();
								boolean change = false; 
								if (size.x < minimum.x) {
									size.x = minimum.x;
									change = true; 
								}	
								if (size.y < minimum.y) {
									size.y = minimum.y;
									change = true; 
								}				
								if (change) 
									shell.setSize(size);
							}
						});
						//shell.setMaximized(true);
						shell.pack();
						shell.open();
					}
				});
			}
		});
		btnClearClone.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						resetText(txtSrc1M);
						resetText(txtSrc2M);
					}
				});
			}
		});
		btnDiff1.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						//resetTexts();
						if(ast1M == null || ast1N == null)
							return;
						setDiffedText(txtSrc1M, tree1M, ast1M);
						setDiffedText(txtSrc1N, tree1N, ast1N);
					}
				});
			}
		});
		btnShowDiff1.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						if(ast1M == null || ast1N == null)
							return;
						MapSourceFile file1M = new MapSourceFile(ast1M.toString());
						MapSourceFile file2M = new MapSourceFile(ast1N.toString());
						file1M.buildBlockCommentLines();
						file2M.buildBlockCommentLines();
						
						LineDiff lineDiff = new LineDiff(file1M, file2M);
						ArrayList<ArrayList<Integer>> diff = lineDiff.doDiffO();
						file1M.setUnchangedLines(diff.get(0));
						file2M.setUnchangedLines(diff.get(1));
						TreeMapper mapper = new TreeMapper(file1M, file2M);
						mapper.map();
						
						Shell shell = new Shell(getDisplay());
						shell.setText("Change Diff");
						shell.setLayout(new FillLayout());
									
						FrmDiff frmDiff = new FrmDiff(shell, SWT.NONE);
						frmDiff.txtSrc1.setText(file1M.getFileContent());
						frmDiff.txtSrc2.setText(file2M.getFileContent());
						setDiffedText(frmDiff.txtSrc1, file1M.getTree(), file1M.getAst());
						setDiffedText(frmDiff.txtSrc2, file2M.getTree(), file2M.getAst());
						final Point minimum = shell.computeSize(SWT.DEFAULT,SWT.DEFAULT,true);
						shell.addControlListener(new ControlAdapter() {
							public void controlResized(ControlEvent e) {
								Shell shell = (Shell)e.widget;
								Point size = shell.getSize();
								boolean change = false; 
								if (size.x < minimum.x) {
									size.x = minimum.x;
									change = true; 
								}	
								if (size.y < minimum.y) {
									size.y = minimum.y;
									change = true; 
								}				
								if (change) 
									shell.setSize(size);
							}
						});
						//shell.setMaximized(true);
						shell.pack();
						shell.open();
					}
				});
			}
		});
		btnClearDiff1.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						resetText(txtSrc1M);
						resetText(txtSrc1N);
					}
				});
			}
		});
		btnDiff2.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						//resetTexts();
						if(ast2M == null || ast2N == null)
							return;
						setDiffedText(txtSrc2M, tree2M, ast2M);
						setDiffedText(txtSrc2N, tree2N, ast2N);
					}
				});
			}
		});
		btnShowDiff2.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						if(ast2M == null || ast2N == null)
							return;
						MapSourceFile file1M = new MapSourceFile(ast2M.toString());
						MapSourceFile file2M = new MapSourceFile(ast2N.toString());
						file1M.buildBlockCommentLines();
						file2M.buildBlockCommentLines();
						
						LineDiff lineDiff = new LineDiff(file1M, file2M);
						ArrayList<ArrayList<Integer>> diff = lineDiff.doDiffO();
						file1M.setUnchangedLines(diff.get(0));
						file2M.setUnchangedLines(diff.get(1));
						TreeMapper mapper = new TreeMapper(file1M, file2M);
						mapper.map();
						
						Shell shell = new Shell(getDisplay());
						shell.setText("Change Diff");
						shell.setLayout(new FillLayout());
									
						FrmDiff frmDiff = new FrmDiff(shell, SWT.NONE);
						frmDiff.txtSrc1.setText(file1M.getFileContent());
						frmDiff.txtSrc2.setText(file2M.getFileContent());
						setDiffedText(frmDiff.txtSrc1, file1M.getTree(), file1M.getAst());
						setDiffedText(frmDiff.txtSrc2, file2M.getTree(), file2M.getAst());
						final Point minimum = shell.computeSize(SWT.DEFAULT,SWT.DEFAULT,true);
						shell.addControlListener(new ControlAdapter() {
							public void controlResized(ControlEvent e) {
								Shell shell = (Shell)e.widget;
								Point size = shell.getSize();
								boolean change = false; 
								if (size.x < minimum.x) {
									size.x = minimum.x;
									change = true; 
								}	
								if (size.y < minimum.y) {
									size.y = minimum.y;
									change = true; 
								}				
								if (change) 
									shell.setSize(size);
							}
						});
						//shell.setMaximized(true);
						shell.pack();
						shell.open();
					}
				});
			}
		});
		btnClearDiff2.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						resetText(txtSrc2M);
						resetText(txtSrc2N);
					}
				});
			}
		});
		btnSync.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getDisplay().syncExec(new Runnable() {
					@Override
					public void run() {
						if(ast2N == null)
							return;
						MapSourceFile file1M = new MapSourceFile(astSync12.toString());
						MapSourceFile file2M = new MapSourceFile(ast2N.toString());
						file1M.buildBlockCommentLines();
						file2M.buildBlockCommentLines();
						
						LineDiff lineDiff = new LineDiff(file1M, file2M);
						ArrayList<ArrayList<Integer>> diff = lineDiff.doDiffO();
						file1M.setUnchangedLines(diff.get(0));
						file2M.setUnchangedLines(diff.get(1));
						TreeMapper mapper = new TreeMapper(file1M, file2M);
						mapper.map();
						
						Shell shell = new Shell(getDisplay());
						shell.setText("Sync Diff");
						shell.setLayout(new FillLayout());
									
						FrmDiff frmDiff = new FrmDiff(shell, SWT.NONE);
						frmDiff.txtSrc1.setText(file1M.getFileContent());
						frmDiff.txtSrc2.setText(file2M.getFileContent());
						setDiffedText(frmDiff.txtSrc1, file1M.getTree(), file1M.getAst());
						setDiffedText(frmDiff.txtSrc2, file2M.getTree(), file2M.getAst());
						final Point minimum = shell.computeSize(SWT.DEFAULT,SWT.DEFAULT,true);
						shell.addControlListener(new ControlAdapter() {
							public void controlResized(ControlEvent e) {
								Shell shell = (Shell)e.widget;
								Point size = shell.getSize();
								boolean change = false; 
								if (size.x < minimum.x) {
									size.x = minimum.x;
									change = true; 
								}	
								if (size.y < minimum.y) {
									size.y = minimum.y;
									change = true; 
								}				
								if (change) 
									shell.setSize(size);
							}
						});
						shell.pack();
						//shell.setMaximized(true);
						shell.open();
									
						/*while (!shell.isDisposed()) {
							if (!getDisplay().readAndDispatch())
								getDisplay().sleep();
						}*/
					}
				});
			}
		});
	}
	
	private void toggleTextWrap() {
		toggleTextWrap(this.txtSrc1M);
		toggleTextWrap(this.txtSrc2M);
		toggleTextWrap(this.txtSrc1N);
		toggleTextWrap(this.txtSrc2N);
	}
	private void toggleTextWrap(StyledText text) {
		text.setWordWrap(!text.getWordWrap());
	}

	protected void setSource(String path) {
		File sub = new File(path);
		String[] pair = sub.getName().split("_");
		//System.out.println("\t\t\t" + pair[0] + "_old.txt");
		String[] contents1M = CloneSync.getFileContent(new File(sub.getAbsolutePath() + "\\" + pair[0] + "_old.java"));
		String[] contents1N = CloneSync.getFileContent(new File(sub.getAbsolutePath() + "\\" + pair[0] + "_new.java"));
		String[] contents2M = CloneSync.getFileContent(new File(sub.getAbsolutePath() + "\\" + pair[1] + "_old.java"));
		String[] contents2N = CloneSync.getFileContent(new File(sub.getAbsolutePath() + "\\" + pair[1] + "_new.java"));
		ASTNode ast1M = ASTNodeWrapper.createAST(contents1M[1]);
		this.label1M.setText(contents1M[0]);
		ASTNode ast1N = ASTNodeWrapper.createAST(contents1N[1]);
		this.label1N.setText(contents1N[0]);
		ASTNode ast2M = ASTNodeWrapper.createAST(contents2M[1]);
		this.label2M.setText(contents2M[0]);
		ASTNode ast2N = ASTNodeWrapper.createAST(contents2N[1]);
		this.label2N.setText(contents2N[0]);
		if(ast1M == null || ast1N == null || ast2M == null || ast2N == null)
		{
			this.txtSrc1M.setText(contents1M[1]);
			this.txtSrc1N.setText(contents1N[1]);
			this.txtSrc2M.setText(contents2M[1]);
			this.txtSrc2N.setText(contents2N[1]);
			MessageBox mb = new MessageBox(getShell(), SWT.ERROR | SWT.OK);
			mb.setText("JSync");
			mb.setMessage("Error while creating AST!");
			mb.open();
			return;
		}
		this.txtSrc1M.setText(ast1M.toString());
		//this.txtSrc1M.setToolTipText(contents1M[0]);
		//System.out.println("\t\t\t" + pair[0] + "_new.txt");
		this.txtSrc1N.setText(ast1N.toString());
		//this.txtSrc1N.setToolTipText(contents1N[0]);
		//System.out.println("\t\t\t" + pair[1] + "_old.txt");
		this.txtSrc2M.setText(ast2M.toString());
		//this.txtSrc2M.setToolTipText(contents2M[0]);
		//System.out.println("\t\t\t" + pair[1] + "_new.txt");
		this.txtSrc2N.setText(ast2N.toString());
		//this.txtSrc2N.setToolTipText(contents2N[0]);
		resetTexts();
		CloneMapper cloneMapper = new CloneMapper(ast1M, ast2M, ast1N, ast2N);
		cloneMapper.mapNaming();
		try {
			cloneMapper.synchronize();
		} catch (Exception e) {
			/*MessageBox mb = new MessageBox(getShell(), SWT.ERROR | SWT.OK);
			mb.setText("JSync");
			mb.setMessage("Error while synchronizing! " + e.getMessage());
			mb.open();
			e.printStackTrace();*/
			//return;
		}
		String sync = ASTNodeWrapper.getContent(cloneMapper.astSync12);
		//System.out.println(sync);
		try {
			PrintStream out = new PrintStream(new FileOutputStream(sub.getAbsolutePath() + "\\" + sub.getName() + ".java"));
			out.println(contents2N[0]);
			out.print(sync);
			out.flush();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		this.ast1M = cloneMapper.ast1M;
		this.ast2M = cloneMapper.ast2M;
		this.ast1N = cloneMapper.ast1N;
		this.ast2N = cloneMapper.ast2N;
		this.tree1M = cloneMapper.tree1M;
		this.tree2M = cloneMapper.tree2M;
		this.tree1N = cloneMapper.tree1N;
		this.tree2N = cloneMapper.tree2N;
		this.astSync12 = cloneMapper.astSync12;
	}
	
	public void setClonedText(StyledText txtSrc, HashMap<ASTNode, ArrayList<ASTNode>> tree, ASTNode root)
	{
		if(root.getProperty(CloneMapper.propertyCloneMapStatus) != null)
		{
			int status = (Integer)root.getProperty(CloneMapper.propertyCloneMapStatus);
			int start = root.getStartPosition(), length = root.getLength();
			switch(status)
			{
			case MapVisitor.STATUS_ADDED: 
				StyleRange styleRange = createRange(start, length, COLOR_ADD);
				txtSrc.setStyleRange(styleRange);
				break;
			case MapVisitor.STATUS_DELETED:
				styleRange = createRange(start, length, COLOR_ADD);
				/*if(root.getProperty(MapVisitor.propertyIsLeaf) != null)
					styleRange.strikeout = true;*/
				txtSrc.setStyleRange(styleRange);
				break;
			case MapVisitor.STATUS_MOVED:
				styleRange = createRange(start, length, COLOR_MOD_IN);
				txtSrc.setStyleRange(styleRange);
				break;
			case MapVisitor.STATUS_RELABELED:
				styleRange = createRange(start, length, COLOR_MOD_IN);
				txtSrc.setStyleRange(styleRange);
				break;
			default:
				styleRange = createRange(start, length, COLOR_BLACK);
			txtSrc.setStyleRange(styleRange);
			break;
			}
		}
		ArrayList<ASTNode> children = tree.get(root);
		for(ASTNode child : children)
		{
			setClonedText(txtSrc, tree, child);
		}
	}
	
	public void setDiffedText(StyledText txtSrc, HashMap<ASTNode, ArrayList<ASTNode>> tree, ASTNode root)
	{
		if(root.getProperty(MapVisitor.propertyStatus) != null)
		{
			int status = (Integer)root.getProperty(MapVisitor.propertyStatus);
			int start = root.getStartPosition(), length = root.getLength();
			switch(status)
			{
				case MapVisitor.STATUS_ADDED: 
					StyleRange styleRange = createRange(start, length, COLOR_ADD);
					txtSrc.setStyleRange(styleRange);
					break;
				case MapVisitor.STATUS_DELETED:
					styleRange = createRange(start, length, COLOR_ADD);
					/*if(root.getProperty(MapVisitor.propertyIsLeaf) != null)
						styleRange.strikeout = true;*/
					txtSrc.setStyleRange(styleRange);
					break;
				case MapVisitor.STATUS_MOVED:
					styleRange = createRange(start, length, COLOR_MOD_IN);
					txtSrc.setStyleRange(styleRange);
					break;
				case MapVisitor.STATUS_RELABELED:
					styleRange = createRange(start, length, COLOR_MOD_IN);
					txtSrc.setStyleRange(styleRange);
					break;
				default:
					styleRange = createRange(start, length, COLOR_BLACK);
					txtSrc.setStyleRange(styleRange);
					break;
			}
		}
		ArrayList<ASTNode> children = tree.get(root);
		for(ASTNode child : children)
		{
			setDiffedText(txtSrc, tree, child);
		}
	}
	
	private void resetMenus()
	{
		miView1.setSelection(true);
	    miViewLate.setSelection(true);
	    miView2.setSelection(true);
	    miViewT.setSelection(true);
	    miViewF.setSelection(true);
	    miSI.setSelection(false);
	    miNI.setSelection(false);
	    miLI.setSelection(false);
	    miViewInteresting.setSelection(false);
	}
	
	private void resetTexts()
	{
		resetText(this.txtSrc1M);
		resetText(this.txtSrc2M);
		resetText(this.txtSrc1N);
		resetText(this.txtSrc2N);
	}
	
	private void resetText(StyledText text)
	{
		text.setStyleRange(createRange(0, text.getText().length(), COLOR_BLACK));
	}
	
	private StyleRange createRange(int start, int length, Color color) {
		StyleRange styleRange = new StyleRange();
		styleRange.start = start;
		styleRange.length = length; 
		styleRange.fontStyle = SWT.BOLD;
		styleRange.foreground= color;
		return styleRange;
	}
	
	private void open()
	{
		String path = this.cloneDataPath;
		boolean side1 = this.miView1.getSelection();
		boolean sideLate = this.miViewLate.getSelection(); 
		boolean side2 = this.miView2.getSelection();
		boolean syncT = this.miViewT.getSelection();
		boolean syncF = this.miViewF.getSelection();
		boolean interesting = this.miViewInteresting.getSelection();
		boolean si = this.miSI.getSelection(), ni = this.miNI.getSelection(), li = this.miLI.getSelection();
		
		this.treeRevisions.removeAll();
		int index = path.lastIndexOf("\\");
		String name = path.substring(index+1);
		String[] parts = name.split("_");
		this.systemName = parts[0];
		ArrayList<Integer> fixRevs = CloneSync.getFixRevisions(path+ "\\..\\" + this.systemName + "_fix_bug_revisions.txt");
		ArrayList<Integer> cloneRevs = CloneSync.getCloneRevisions(path + "\\inconsistencies");
		if (fixRevs != null)
			cloneRevs.retainAll(fixRevs);
		Collections.sort(cloneRevs);
		System.out.println(this.systemName);
		for(int rev : cloneRevs)
		{
			//System.out.println("\t" + rev);
			TreeItem itemRev = new TreeItem(this.treeRevisions, SWT.NONE);
			itemRev.setText(rev + "");
			File dir = new File(path + "\\inconsistencies\\" + rev);
			File[] files = dir.listFiles();
			Arrays.sort(files);
			HashSet<String> dupPairs = new HashSet<String>();
			for(File sub : files)
			{
				if(!dupPairs.contains(sub.getName()))
				{
					String[] pairs = sub.getName().split("_");
					dupPairs.add(pairs[1] + "_" + pairs[0]);
					ClonePairSyncInfo info = new ClonePairSyncInfo();
					boolean done = info.readSyncInfoFile(sub.getAbsolutePath() + "\\info.txt");
					//System.out.println(info.inconsistent);
					if (done)
					{
						done = ((side1 && ((info.change == 1) && (!info.lateSync))) || (sideLate && info.lateSync) || (side2 && (info.change == 2)))
								&& ((syncT && info.jSync) || (syncF && !info.jSync))
								&& (!interesting || (!info.comment.isEmpty()));
						if (done)
						{
							done = (!si && !ni && !li) ||
									((si == info.inconsistent.contains("S")) 
									&& (ni == info.inconsistent.contains("N")) 
									&& (li == info.inconsistent.contains("L")));
						}
					}
					if(done)
					{
						TreeItem itemPair = new TreeItem(itemRev, SWT.NONE);
						itemPair.setText(sub.getName());
						itemPair.setForeground(getDisplay().getSystemColor(SWT.COLOR_BLUE));
					}
				}
			}
		}
	}
	
	private void open(String path)
	{
		resetMenus();
		resetTexts();
		this.treeRevisions.removeAll();
		int index = path.lastIndexOf("\\");
		String name = path.substring(index+1);
		String[] parts = name.split("_");
		this.systemName = parts[0];
		ArrayList<Integer> fixRevs = CloneSync.getFixRevisions(path+ "\\..\\" + this.systemName + "_fix_bug_revisions.txt");
		ArrayList<Integer> cloneRevs = CloneSync.getCloneRevisions(path + "\\inconsistencies");
		if (fixRevs != null)
			cloneRevs.retainAll(fixRevs);
		Collections.sort(cloneRevs);
		System.out.println(this.systemName);
		for(int rev : cloneRevs)
		{
			System.out.println("\t" + rev);
			TreeItem itemRev = new TreeItem(this.treeRevisions, SWT.NONE);
			itemRev.setText(rev + "");
			File dir = new File(path + "\\inconsistencies\\" + rev);
			File[] files = dir.listFiles();
			Arrays.sort(files);
			HashSet<String> dupPairs = new HashSet<String>();
			for(File sub : files)
			{
				if(!dupPairs.contains(sub.getName()))
				{
					String[] pairs = sub.getName().split("_");
					dupPairs.add(pairs[1] + "_" + pairs[0]);
					System.out.println("\t\t" + sub.getName());
					TreeItem itemPair = new TreeItem(itemRev, SWT.NONE);
					itemPair.setText(sub.getName());
					ClonePairSyncInfo info = new ClonePairSyncInfo();
					boolean done = info.readSyncInfoFile(sub.getAbsolutePath() + "\\info.txt");
					if(done)
						itemPair.setForeground(getDisplay().getSystemColor(SWT.COLOR_BLUE));
				}
			}
		}
	}
	
	public static void main(String[] args) {
		Display display = new Display();
		Shell shell = new Shell(display);
		shell.setText("JSync");
		shell.setLayout(new FillLayout());
					
		FrmCloneSync cloneSyncExplorer = new FrmCloneSync(shell,SWT.NONE);
		final Point minimum = shell.computeSize(SWT.DEFAULT,SWT.DEFAULT,true);
		shell.addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				Shell shell = (Shell)e.widget;
				Point size = shell.getSize();
				boolean change = false; 
				if (size.x < minimum.x) {
					size.x = minimum.x;
					change = true; 
				}	
				if (size.y < minimum.y) {
					size.y = minimum.y;
					change = true; 
				}				
				if (change) 
					shell.setSize(size);
			}
		});
		shell.setMaximized(true);
		shell.open();
					
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}
}