package CloneTransforming;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

public class FrmDiff extends Composite {
	private Menu menuBar;
	private MenuItem menuWrapText, menuExitItem;
	public StyledText txtSrc1, txtSrc2;
	
	public FrmDiff(Composite parent, int style) {
		super(parent, style);
		
		menuBar = new Menu(getShell(), SWT.BAR);
		menuExitItem = new MenuItem(menuBar, SWT.PUSH);
	    menuExitItem.setText("E&xit");
	    menuWrapText = new MenuItem(menuBar, SWT.CHECK);
	    menuWrapText.setText("&Wrap Text");
	    
	    menuExitItem.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				getShell().close();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				getShell().close();
			    //getDisplay().dispose();
			}
		});
	    menuWrapText.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				toggleTextWrap();
			}
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				toggleTextWrap();
			}
		});
	    
	    parent.getShell().setMenuBar(menuBar);
	    
	    GridLayout gridLayout = new GridLayout();
		super.setLayout(gridLayout);
		
		SashForm frmMain = new SashForm(this, SWT.HORIZONTAL);
		frmMain.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL | 
				GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		txtSrc1 = new StyledText(frmMain, SWT.BORDER | SWT.READ_ONLY | SWT.H_SCROLL | SWT.V_SCROLL);
		txtSrc1.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL 
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		txtSrc2 = new StyledText(frmMain, SWT.BORDER | SWT.READ_ONLY | SWT.H_SCROLL | SWT.V_SCROLL);
		txtSrc2.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL 
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
	}

	private void toggleTextWrap() {
		toggleTextWrap(this.txtSrc1);
		toggleTextWrap(this.txtSrc2);
	}
	private void toggleTextWrap(StyledText text) {
		text.setWordWrap(!text.getWordWrap());
	}
	
}
