package cleman;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.ArrayList;

public class CheckReport {
	public static HashMap<SourceFile, ArrayList<Integer>> linesOfFiles = new HashMap<SourceFile, ArrayList<Integer>>();
	public HashSet<Integer> simscanCGs = new HashSet<Integer>();
	public HashSet<Integer> ccfinderCGs = new HashSet<Integer>();
	public static HashMap<SourceFile, boolean[]> clemanLinesInFiles = new HashMap<SourceFile, boolean[]>();
	public static HashMap<SourceFile, boolean[]> simscanLinesInFiles = new HashMap<SourceFile, boolean[]>();
	public static HashMap<Integer, boolean[]> ccfinderLinesInFiles = new HashMap<Integer, boolean[]>();
	
	public void doCheck()
	{
		//buildLinesOfFiles(Main.applicationPath);
		buildLinesOfFiles();
		buildClemanLinesOfFiles();
		//buildSimscanLinesOfFiles();
		//buildCCFinderLinesOfFiles();
		/*compareReport(clemanLinesInFiles, "Cleman", simscanLinesInFiles, "SimScan");
		compareReport(clemanLinesInFiles, "Cleman", ccfinderLinesInFiles, "CCFinder");*/
		System.out.println("Coverage:");
		countLines(clemanLinesInFiles, "Cleman");
		//countLines(simscanLinesInFiles, "SimScan");
		//countLines(ccfinderLinesInFiles, "CCFinder");
		System.out.println("Number of groups:");
		System.out.println("Cleman: " + Group.all.size());
		//System.out.println("SimScan: " + this.simscanCGs.size());
		//System.out.println("CCFinder: " + this.ccfinderCGs.size());
		//printCloneMap("D:\\Iowa State Uni\\Projects\\Ceman\\jEdit3\\bsh\\Reflect.java");
	}
	public void buildLinesOfFiles()
	{
		linesOfFiles = new HashMap<SourceFile, ArrayList<Integer>>();
		
		for(SourceFile sf : SourceFile.all.values())
		{
			ArrayList<Integer> lines = new ArrayList<Integer>();
			lines.add(0);
			try {
				String dir = Main.applicationPath + "\\" + sf.fileLocation;
				BufferedReader in4lines = new BufferedReader(new FileReader(dir));
				int charCount = 0, lineCount = 0;
				String oneLine = null;
				while((oneLine = in4lines.readLine()) != null) {
					lineCount++;
					lines.add(charCount);
					charCount += oneLine.length() + 2;
				}
				//System.out.println(dir.getAbsolutePath() + "\t" + lineCount);
				lines.set(0, lineCount);
				linesOfFiles.put(sf, lines);
				in4lines.close();
			}
			catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	/*public void buildLinesOfFiles(String path)
	{
		linesOfFiles = new HashMap<SourceFile, ArrayList<Integer>>();
		
		File dir = new File(path);
		if (dir.isFile()) {
			if (dir.getName().endsWith(".java")) {
				ArrayList<Integer> lines = linesOfFiles.get(dir.getAbsoluteFile());
				if (lines != null) return;
				lines = new ArrayList<Integer>();
				lines.add(0);
				try {
					BufferedReader in4lines = new BufferedReader(new FileReader(dir));
					int charCount = 0, lineCount = 0;
					String oneLine = null;
					//boolean inComment = false;
					//int commentLines = 0;
					while((oneLine = in4lines.readLine()) != null) {
						lineCount++;
						lines.add(charCount);
						charCount += oneLine.length() + 2;
						
						String str = oneLine;
						String trimmed = str.trim();
						if (trimmed != "") {
							if (trimmed.startsWith("//"))
								commentLines++;
							if (!inComment) {
								if (trimmed.indexOf("/*") > -1) {
									inComment = true;
									commentLines++;
								}
							}
							else {
								commentLines++;
								if (trimmed.lastIndexOf("*\/") > -1) {
									inComment = false;
									
								}
								else {
									String strTmp = replaceChar(str, " ");
									str = strTmp;
								}
							}
						}
					}
					//System.out.println(dir.getAbsolutePath() + "\t" + lineCount);
					lines.set(0, lineCount);
					String relativePath = dir.getAbsolutePath().substring(Main.applicationPath.length());
					linesOfFiles.put(SourceFile.all.get(relativePath), lines);
					in4lines.close();
				}catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		else {
			File[] fileList = dir.listFiles();
			for (File file : fileList) {
				if (file.isDirectory() || file.getName().endsWith(".java")) {
					buildLinesOfFiles(file.getAbsolutePath());
				}
			}
		}
	}*/
	//public void buildClonedLinesOfFiles(HashMap<Integer, ArrayList<Boolean>> clonedLinesInFiles) {
	public void buildClemanLinesOfFiles() {
		clemanLinesInFiles = new HashMap<SourceFile, boolean[]>();
		
		for (Group cg : Group.all.values()) {
			if (cg.fragments != null && !cg.fragments.isEmpty()) {
				for (Fragment frag : cg.fragments) {
					SourceFile sf =  frag.getSourceFile();
					boolean[] clonedLines = clemanLinesInFiles.get(sf);
					if (clonedLines == null) {
						if(!SourceFile.all.containsKey(sf.fileLocation))
							System.out.println(frag);
						//System.out.println(sf.fileLocation + "\t" + sf.fileID + "\t" + SourceFile.all.get(sf.fileLocation).fileID);
						/*if(!linesOfFiles.containsKey(sf))
						{
							System.out.println(sf.fileLocation + "\t" + sf.fileID + "\t" + SourceFile.all.get(sf.fileLocation).fileID);
						}*/
						clonedLines = new boolean[linesOfFiles.get(sf).get(0)+1];
						for (int i = 1; i <= linesOfFiles.get(sf).get(0); i++) {
							clonedLines[i] = false;
						}
					}
					ArrayList<Integer> lines = linesOfFiles.get(sf); 
					int start = binSearch(frag.getStartChar(), lines);
					int end = binSearch(frag.getStartChar() + frag.getLength() - 1, lines);
					for (int i = start; i <= end; i++) {
						clonedLines[i] = true;
					}
					clemanLinesInFiles.put(sf, clonedLines);
				}
			}
		}
	}
	public void buildSimscanLinesOfFiles() throws IOException {
		File file = new File(Main.applicationPath + "\\duplicates_summary.txt");	//"\\SimScan_report" + 
		String fileName = null;
		BufferedReader in = new BufferedReader(new FileReader(file));
		String line = null;
		int lineID = 0; 
		while ((line = in.readLine()) != null) {
			lineID++;
			simscanCGs.add(lineID);
			String[] parts = line.split(",");
			for (int i = 0; i < parts.length; i++) {
				int start = Integer.parseInt(parts[i].substring(parts[i].lastIndexOf(":") + 1, parts[i].lastIndexOf("-")));
				int end = Integer.parseInt(parts[i].substring(parts[i].lastIndexOf("-") + 1, parts[i].length()));
				fileName = parts[i].substring(parts[i].indexOf("-") + 1, parts[i].lastIndexOf(":"));
				String relativePath = fileName.substring(Main.applicationPath.length()+1);
				SourceFile sf =  SourceFile.all.get(relativePath);
				boolean[] clonedLines = simscanLinesInFiles.get(sf);
				if (clonedLines == null) {
					clonedLines = new boolean[linesOfFiles.get(sf).get(0)+1];
					for (int j = 1; j <= linesOfFiles.get(sf).get(0); j++) {
						clonedLines[j] = false;
					}
				}
				for (int j = start; j <= end; j++) {
					clonedLines[j] = true;
				}
				simscanLinesInFiles.put(sf, clonedLines);
			}
		}
	}
	/*public void buildCCFinderLinesOfFiles() throws IOException {
		File file = new File(Main.applicationPath + "\\ccfinder_report.txt");
		String fileName = null;
		HashMap<String, String> id2file = new HashMap<String, String>();
		BufferedReader in = new BufferedReader(new FileReader(file));
		String line = null;
		while (((line = in.readLine()) != null) && (line.indexOf("#begin{file description}") == -1));
		while (((line = in.readLine()) != null) && (line.indexOf("#end{file description}") == -1)) {
			String[] parts = line.trim().split("\t");
			id2file.put(parts[0], parts[parts.length - 1]);
		}
		while (((line = in.readLine()) != null) && (line.indexOf("#begin{clone}") == -1));
		while (((line = in.readLine()) != null) && (line.indexOf("#end{clone}") == -1)) {
			String[] parts = line.trim().split("\t"); //split one line: clone 1's info clone 2's info
			for (int i = 0; i < 2; i++) { //for each clone
				String fileID = parts[i*4];	
				fileName = id2file.get(fileID);	//get file id and name
				String [] subparts = parts[i*4 + 1].split(",");	//split FROM part
				int start = Integer.parseInt(subparts[0]);	//start line
				subparts = parts[i*4 + 2].split(",");	//split TO part
				int end = Integer.parseInt(subparts[0]);	//end line
				int groupID = Integer.parseInt(parts[i*4 + 3]);	//group ID
				
				if (!ccfinderCGs.contains(groupID)) ccfinderCGs.add(groupID);
				String relativePath = fileName.substring(Data.applicationPath.length()+1);
				int fID = Data.fileName2ID.get(relativePath);
				int numOfLines = linesOfFiles.get(fID).get(0);
				boolean[] clonedLines = ccfinderLinesInFiles.get(fID);
				if (clonedLines == null) {
					clonedLines = new boolean[numOfLines + 1];
					for (int j = 1; j <= numOfLines; j++) {
						clonedLines[j] = false;
					}
				}
				for (int j = start; j <= end; j++) {
					clonedLines[j] = true;
				}
				ccfinderLinesInFiles.put(fID, clonedLines);
			}
		}
	}*/
	/*public void compareReport(HashMap<Integer, boolean[]> report1, String report1Name, HashMap<Integer, boolean[]> report2, String report2Name) {
		int totalIn1 = 0, totalIn2 = 0, totalInBoth = 0, total = 0;
		for (int fileID : linesOfFiles.keySet()) {
			total += linesOfFiles.get(fileID).get(0);
			boolean[] lines1 = new boolean[linesOfFiles.get(fileID).get(0)+1];
			boolean[] lines2 = new boolean[linesOfFiles.get(fileID).get(0)+1];
			lines1 = report1.get(fileID);
			lines2 = report2.get(fileID);
			int in1 = 0, in2 = 0, inBoth = 0; 
			
			if (lines1 == null) {
				if (lines2 == null)	{
					//System.out.println(Data.files.get(fileID).fileLocation + ": not parsed by both.");
					continue;
				}
				else {
					for (int i = 1; i <= linesOfFiles.get(fileID).get(0); i++) {
						if (lines2[i]) {
							in2++;
						}
					}
				}
			}
			else {
				if (lines2 == null)  {
					for (int i = 1; i <= linesOfFiles.get(fileID).get(0); i++) {
						if (lines1[i]) {
							in1++;
						}
					}
				}
				else {
					for (int i = 1; i <= linesOfFiles.get(fileID).get(0); i++) {
						if (lines1[i] && lines2[i]) {
							inBoth++;
						}
						if (lines1[i] && !lines2[i]) {
							in1++;
						}
						if (!lines1[i] && lines2[i]) {
							in2++;
						}
					}
				}
			}
			System.out.println(linesOfFiles.get(fileID).get(0) + " lines,\t"+ 
					inBoth + " in both,\t" +
					in1 + " only in " + report1Name + ",\t" +
					in2 + " only in " + report2Name + ",\t" + Data.files.get(fileID).fileLocation);
			totalIn1 += in1;
			totalIn2 += in2;
			totalInBoth += inBoth;
		}
		System.out.println("Summary: " + linesOfFiles.size() + " files");
		System.out.println(totalInBoth + " in both, " +
				totalIn1 + " only in " + report1Name + "," +
				totalIn2 + " only in " + report2Name);
		System.out.println("Coverage:");
		System.out.println(report1Name + ": " + (totalIn1 + totalInBoth) + "/" + total);
		System.out.println(report2Name + ": " + (totalIn2 + totalInBoth) + "/" + total);
	}*/
	public void countLines(HashMap<SourceFile, boolean[]> report1, String report1Name) {
		int totalIn1 = 0, total = 0;
		for (SourceFile sf : linesOfFiles.keySet()) {
			total += linesOfFiles.get(sf).get(0);
			boolean[] lines1 = new boolean[linesOfFiles.get(sf).get(0)+1];
			lines1 = report1.get(sf);
			int in1 = 0; 
			
			if (lines1 == null) {
				continue;
			}
			else {
				for (int i = 1; i <= linesOfFiles.get(sf).get(0); i++) {
					if (lines1[i]) {
						in1++;
					}
				}
			}
			totalIn1 += in1;
		}
		System.out.println(report1Name + ": " + totalIn1 + "/" + total);
		//Data.totalLines = total;
	}
	private int binSearch(int x, ArrayList<Integer> al) {
		if (al.size() == 1) return 0;
		int low = 1, high = al.get(0), mid;
		while( low < high ) {
			mid = ( low + high ) / 2;
            if(al.get(mid).compareTo(x) < 0 )
                low = mid + 1;
            else if( al.get(mid).compareTo(x) > 0 )
                high = mid - 1;
            else
                return mid;
        }
		if (al.get(low).compareTo(x) > 0) return low - 1;
		else return low;
	}
	/*public int[] getClonesOfNewFragments(HashSet<Group> groups)
	{
		int[] c = new int[2];
		for(Group g : groups)
		{
			int news = 0;
			for(Fragment f : g.fragments)
			{
				if(SourceFile.addeds.contains(f.getSourceFile()))
				{
					news++;
				}
			}
			if(news > 0)
				c[0]++;
			if(news == g.fragments.size())
				c[1]++;
		}
		return c;
	}*/
	/*public void printCloneMap(String fileName) throws IOException {
		String relativePath = fileName.substring(Data.applicationPath.length()+1);
		int fileID = Data.fileName2ID.get(relativePath);
		BufferedWriter fout = new BufferedWriter(new FileWriter(Data.applicationPath + "\\report\\" + fileID + "Cleman.txt"));
		boolean[] lines = clemanLinesInFiles.get(fileID);
		if (lines != null) {
			for (int i = 1; i < lines.length; i++) {
				fout.write(i + "\t " + lines[i] + "\r\n");
			}
		}
		fout.flush();
		fout.close();
		fout = new BufferedWriter(new FileWriter(Data.applicationPath + "\\report\\" + fileID + "SimScan.txt"));
		lines = simscanLinesInFiles.get(fileID);
		if (lines != null) {
			for (int i = 1; i < lines.length; i++) {
				fout.write(i + "\t " + lines[i] + "\r\n");
			}
		}
		fout.flush();
		fout.close();
		fout = new BufferedWriter(new FileWriter(Data.applicationPath + "\\report\\" + fileID + "CCFinder.txt"));
		lines = ccfinderLinesInFiles.get(fileID);
		if (lines != null) {
			for (int i = 1; i < lines.length; i++) {
				fout.write(i + "\t " + lines[i] + "\r\n");
			}
		}
		fout.flush();
		fout.close();
	}*/
}
