package cleman;

import java.io.Serializable;

public class CloneFragment implements Serializable {
	protected static final long serialVersionUID = 1L;
	
	public String fileName;
	public int startLine, endLine;
	
	public boolean isOverlaped(CloneFragment other)
	{
		if(this.fileName.equals(other.fileName))
		{
			int start1 = this.startLine, end1 = this.endLine;
			int start2 = other.startLine, end2 = other.endLine;
			if(start1 >= start2 && start1 <= end2)
				return true;
			if(end1 >= start2 && end1 <= end2)
				return true;
			if(start2 >= start1 && start2 <= end1)
				return true;
			if(end2 >= start1 && end2 <= end1)
				return true;
		}
		return false;
	}
	
	public int[] match(CloneFragment other)
	{
		int[] matches = new int[2];
		int start1 = this.startLine, end1 = this.endLine;
		int start2 = other.startLine, end2 = other.endLine;
		matches[0] = 0;
		matches[1] = end1 - start1 + end2 - start2 + 2;
		if(this.fileName.equals(other.fileName))
		{
			if(start1 >= start2 && start1 <= end2)
			{
				matches[0] = Math.min(end1, end2) - start1 + 1;
				matches[1] = Math.max(end1, end2) - start2 + 1;
			}
			else if(end1 >= start2 && end1 <= end2)
			{
				matches[0] = end1 - Math.max(start1, start2) + 1;
				matches[1] = end2 - Math.min(start1, start2) + 1;
			}
			if(start2 >= start1 && start2 <= end1)
			{
				matches[0] = Math.min(end1, end2) - start2 + 1;
				matches[1] = Math.max(end1, end2) - start1 + 1;
			}
			if(end2 >= start1 && end2 <= end1)
			{
				matches[0] = end2 - Math.max(start1, start2) + 1;
				matches[1] = end1 - Math.min(start1, start2) + 1;
			}
		}
		
		return matches;
	}
}
