package cleman;

import java.io.Serializable;

public class ClonePair implements Serializable {
	protected static final long serialVersionUID = 1L;
	
	public CloneFragment cf1, cf2;
	public int type = 0;
	
	public ClonePair() {
		// TODO Auto-generated constructor stub
	}
	
	public ClonePair(CloneFragment cf1, CloneFragment cf2) {
		int strComp = cf1.fileName.compareTo(cf2.fileName);
		if(strComp < 0 ||
				(strComp == 0 && (cf1.startLine < cf2.startLine || (cf1.startLine == cf2.startLine && cf1.endLine < cf2.endLine)))
				)
		{
			this.cf1 = cf1; this.cf2 = cf2;
		}
		else
		{
			this.cf1 = cf2; this.cf2 = cf1;
		}
	}
	
	public double[] match(ClonePair other)
	{
		double[] matches = new double[2];
		int[] matches1 = this.cf1.match(other.cf1), matches2 = this.cf2.match(other.cf2);
		matches[0] = Math.min(matches1[0]*1.0 / matches1[1], matches2[0]*1.0 / matches2[1]);
		matches[1] = Math.min(
				Math.max(matches1[0]*1.0 / (this.cf1.endLine-this.cf1.startLine+1), matches1[0]*1.0 / (other.cf1.endLine-other.cf1.startLine+1)),
				Math.max(matches2[0]*1.0 / (this.cf2.endLine-this.cf2.startLine+1), matches2[0]*1.0 / (other.cf2.endLine-other.cf2.startLine+1)));
		return matches;
	}
}
