package cleman;

import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Iterator;

import org.tmatesoft.svn.core.SVNDirEntry;
import org.tmatesoft.svn.core.SVNNodeKind;
import org.tmatesoft.svn.core.io.SVNRepository;

import repositoryConnecting.SVNChangedFiles;
import repositoryConnecting.SVNConnector;
import treeMapping.ChangedFile;
import treeMapping.LineDiff;
import treeMapping.Locater;
import treeMapping.MapSourceFile;
import treeMapping.TreeMapper;

public class FileChecking {
	
	/**
	 * This will contain the files that needs to be added (new files/modified files)
	 */
	//public ArrayList<String> addedFiles = null;
	public int addeds = 0, addedFragments = 0, added2Exists = 0;
	public int changedLines = 0;
	/**
	 * This will contain the files that needs to be deleted (deleted files/modified files)
	 */
	HashMap<String, SourceFile> deletedFiles;
	HashSet<String> delFiles = new HashSet<String>(), addFiles = new HashSet<String>(), modFiles = new HashSet<String>(), unFiles = new HashSet<String>();
	public int modifieds = 0, deleteds = 0, deletedFragments = 0;
	
	public ArrayList<ChangedFile> changedFiles = new ArrayList<ChangedFile>();
	
	public FileChecking()
	{
		deletedFiles = new HashMap<String, SourceFile>(SourceFile.all);
	}
	/**
	 * This method will check our application if there are any changes	 
	 */
	/*public void CheckDifferences()
	{
		try
		{
			//addFiles=new ArrayList<String>();
			deletedFiles = new HashSet<SourceFile>(SourceFile.all.values());
			
			//check= ((Hashtable<Integer,SourceFile>)Data.files.clone()).keySet();		
			doCheck(new File(Main.applicationPath));			
			
		}
		catch(Exception ex)
		{
			System.out.println("FileChecking - CheckDifferences: "+ex.getMessage());			
		}
	}*/
	
	/**
	 * This method will run recursively to check all files
	 * @param fileToCheck File class instance that points to current location.
	 */
	/*public void doCheck(File fileToCheck) {
		File[] orgFiles = fileToCheck.listFiles();
		
		SourceFile tmpFile = null;
		String relativePath;
		int temp = Main.applicationPath.length()+1;
		
		for(File file : orgFiles)
		{
			relativePath = file.getAbsolutePath().substring(temp);
			if(file.isDirectory())
				doCheck(file);
			else if(relativePath.endsWith(".java"))
			{
				tmpFile = SourceFile.all.get(relativePath);
				
				if(tmpFile == null || (tmpFile.fileSize != file.length()))
				{
					if (tmpFile != null) {
						this.modifieds++;
						this.deleteds--;
						this.deletedFiles.remove(tmpFile.fileLocation);
						//System.out.println(tmpFile.fileLocation);
						deleteFile(tmpFile);
					}
					else {
						this.addeds++;
					}
					
					SourceFile sf = new SourceFile(file);
					sf.lastModified = file.lastModified();
					sf.fileSize = file.length();
					SourceFile.all.put(sf.fileLocation, sf);
					for(Fragment f : sf.fragments)
						Fragment.addeds.put(f.getId(), f);
					if(tmpFile == null)
					{
						SourceFile.addeds.add(sf);
						this.addedFragments += sf.fragments.size();
					}
				}
				else {
					this.deletedFiles.remove(tmpFile.fileLocation);
					this.deleteds--;
				}
			}
		}
	}*/
	public void doCheck(SVNRepository repository, String path, long preRevision, long currentRevision)
	{
		try {
			Collection entries = repository.getDir(path, currentRevision, null, (Collection)null);
			Iterator iterator = entries.iterator();
			while (iterator.hasNext()) {
				SVNDirEntry entry = (SVNDirEntry)iterator.next();
				if(entry.getKind() == SVNNodeKind.FILE)
				{
					if(entry.getName().endsWith(".java"))
					{
						ByteArrayOutputStream out = new ByteArrayOutputStream();
						String fileName = (path.equals("") ? "" : path + "/") + entry.getName();
						repository.getFile(fileName, currentRevision, null, out);
						if(SourceFile.all.containsKey(fileName))
						{
							delFiles.remove(fileName);
							SourceFile tmpFile = SourceFile.all.get(fileName);
							if(tmpFile.fileSize != out.size())
							{
								modFiles.add(fileName);
							}
							else
								unFiles.add(fileName);
						}
						else
						{
							addFiles.add(fileName);
						}
					}
				}
				else if (entry.getKind() == SVNNodeKind.DIR) {
					doCheck(repository, (path.equals("")) ? entry.getName() : path + "/" + entry.getName(), preRevision, currentRevision);
				}
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	public void getChanges(SVNRepository repository, long preRevision, long currentRevision)
	{
		SVNChangedFiles svnChange = new SVNChangedFiles(repository);
        svnChange.getDiffStatus(preRevision, currentRevision, delFiles, addFiles, modFiles);
	}
	public void doCheck(String username, String pass, String url, long preRevision, long currentRevision)
	{
		//delFiles = new HashSet<String>(SourceFile.all.keySet());
		//doCheck(Main.repository, "", preRevision, currentRevision);
		getChanges(Main.repository, preRevision, currentRevision);
		
		SVNConnector svnConnector = new SVNConnector(url, username, pass);
		svnConnector.connect();
		
		for(String fileName : delFiles)
		{
			System.out.println("This file was deleted: " + fileName + "\n");
			deleteds++;
			//deleteFile(SourceFile.all.get(fileName));
			for(int id: SourceFile.all.get(fileName).fragments)
			{
				Fragment fragment = Fragment.all.get(id);
				Fragment.deleteds.put(id, fragment);
				Fragment.all.remove(id);
			}
			SourceFile.all.remove(fileName);
		}
		for(String fileName : addFiles)
		{
			//System.out.println("This file was newly added: " + fileName + "\n");
			addeds++;
			String fileContent = svnConnector.getFile(fileName, currentRevision);
			SourceFile sf = new SourceFile(fileContent, null,fileName);
			sf.fileLocation = fileName;
			sf.fileSize = fileContent.length();
			SourceFile.all.put(fileName, sf);
		}
		/*for(String fileName : unFiles)
		{
			MapSourceFile fileN = new MapSourceFile(svnConnector.getFile(fileName, currentRevision));
			UnchangeVisitor sidVisitor = new UnchangeVisitor(SourceFile.all.get(fileName).fragments);
			fileN.getAst().accept(sidVisitor);
			sidVisitor = null;
		}*/
		for(String fileName : modFiles)
		{
			modifieds++;
			
			MapSourceFile fileM = new MapSourceFile(svnConnector.getFile(fileName, preRevision));
			MapSourceFile fileN = new MapSourceFile(svnConnector.getFile(fileName, currentRevision));
			LineDiff lineDiff = new LineDiff(fileM, fileN);
			ArrayList<ArrayList<Integer>> diff = lineDiff.doDiff();
			if(diff.get(0).isEmpty() && diff.get(1).isEmpty())
				continue;
			
			fileM.setFilePath(fileName);
			fileM.buildBlockCommentLines();
			fileM.setUnchangedLines(diff.get(0));
			
			fileN.setFilePath(fileName);
			fileN.buildBlockCommentLines();
			fileN.setUnchangedLines(diff.get(1));
			
			TreeMapper mapper = new TreeMapper(fileM, fileN);
			mapper.map();
			System.out.println("Finish mapping " + fileName);
			System.out.println();
			SequenceIDVisitor sidVisitor = new SequenceIDVisitor(SourceFile.all.get(fileName).fragments);
			fileM.getAst().accept(sidVisitor);
			sidVisitor = null;
			
			SourceFile sf = new SourceFile(fileN.getAst(), SourceFile.all.get(fileName).fragments,fileN.getFileContent());
			sf.fileLocation = fileName;
			sf.fileSize = fileN.getFileContent().length();
			SourceFile.all.put(fileName, sf);
		}
	}
	/*public void doCheck(SVNRepository repository, String path, long preRevision, long currentRevision)
	{
		try {
			Collection entries = repository.getDir(path, currentRevision, null, (Collection)null);
			Iterator iterator = entries.iterator();
			while (iterator.hasNext()) {
				SVNDirEntry entry = (SVNDirEntry)iterator.next();
				if(entry.getKind() == SVNNodeKind.FILE)
				{
					if(entry.getName().endsWith(".java"))
					{
						ByteArrayOutputStream out = new ByteArrayOutputStream();
						String fileName = path + "/" + entry.getName();
						repository.getFile(fileName, currentRevision, null, out);
						if(SourceFile.all.containsKey(fileName))
						{
							this.deletedFiles.remove(fileName);
							SourceFile tmpFile = SourceFile.all.get(fileName);
							if(tmpFile.fileSize != out.size())
							{
								this.modifieds++;
								deleteFile(tmpFile);
								SourceFile sf = new SourceFile(out.toString(), null);
								sf.fileLocation = fileName;
								sf.fileSize = out.size();
								SourceFile.all.put(fileName, sf);
								
								for(Fragment f : sf.fragments)
									Fragment.addeds.put(f.getId(), f);
								this.addedFragments += sf.fragments.size();
							}
						}
						else
						{
							this.addeds++;
							SourceFile sf = new SourceFile(out.toString(), null);
							sf.fileLocation = fileName;
							sf.fileSize = out.size();
							SourceFile.all.put(fileName, sf);
							
							for(Fragment f : sf.fragments)
								Fragment.addeds.put(f.getId(), f);
							SourceFile.addeds.add(sf);
							this.addedFragments += sf.fragments.size();
						}
					}
				}
				else if (entry.getKind() == SVNNodeKind.DIR) {
					doCheck(repository, (path.equals("")) ? entry.getName() : path + "/" + entry.getName(), preRevision, currentRevision);
				}
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}*/
	/*void deleteFile(SourceFile sf) {
		for (Fragment f : sf.fragments) {
			if (f.getGroup() != null) {
				Group g = f.getGroup(); 
				g.removeFragment(f);
				if (g.fragments.isEmpty())
					Group.all.remove(g.id);
			}
			HashSet<Bucket> bs = new HashSet<Bucket>(f.getBuckets());
			for (Bucket b : bs) {
				b.removeFragment(f);
				if(b.fragments.isEmpty())
					Bucket.all.remove(b.id);
			}
			Fragment.all.remove(f.getId());
		}
		this.deletedFragments += sf.fragments.size();
		SourceFile.all.remove(sf.fileLocation);
	}*/
	/*public void deleteFiles() {
		//System.out.println(this.deletedFiles.size());
		this.deleteds = this.deletedFiles.size();
		for (SourceFile sf : this.deletedFiles.values()) {
			deleteFile(sf);
		}
		//this.deletedFragments = Fragment.deleteds.size();
	}*/
}
