package cleman;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Stack;

import org.eclipse.jdt.core.dom.*;

import treeMapping.MapVisitor;
import treeMapping.TreeMapper;


/**
 * @author Nguyen Anh Hoan
 *
 */
class UnchangeVisitor extends ASTVisitor {
	public static final String propertySequenceID = "sid";
	private int sid = 0;
	private int lastNode = 0;	//for end token of vector
	private Stack<Integer> stackCurrentNode = new Stack<Integer>();	//for start token of vector
	private ArrayList<Fragment> fragments = new ArrayList<Fragment>();
	
    public UnchangeVisitor(ArrayList<Fragment> fragments)
    {
    	this.fragments = fragments;
    }
    public void preVisit(ASTNode node) {
    	int nodeType = node.getNodeType(); 
    	if (nodeType == ASTNode.JAVADOC || nodeType == ASTNode.BLOCK_COMMENT || nodeType == ASTNode.LINE_COMMENT)
    		return;
    	stackCurrentNode.push(++lastNode); 
    }
    public void postVisit(ASTNode node) {
    	int nodeType = node.getNodeType();
    	if (nodeType == ASTNode.JAVADOC || nodeType == ASTNode.BLOCK_COMMENT || nodeType == ASTNode.LINE_COMMENT)
    		return;
    	int currentNode = stackCurrentNode.pop();
    	if(nodeType != ASTNode.EXPRESSION_STATEMENT && nodeType != ASTNode.BLOCK && nodeType != ASTNode.PARENTHESIZED_EXPRESSION && lastNode-currentNode+1 >= Main.minFragmentSize)
		{
    		Fragment fragment = fragments.get(sid);
    		//fragment.setAstNode(node);
			Fragment.unchangeds.put(fragment.getId(), fragment);
			Fragment.all.remove(fragment.getId());
    		node.setProperty(propertySequenceID, sid++);
		}
    	
    }
 }
