package report;

import java.io.File;
import java.util.Arrays;
import java.util.HashSet;

public class CountInconsistencies {
	public static void main(String[] args) {
		String path = "D:\\projects\\JSync\\changes\\jfreechart_30_locations_1_2272\\inconsistencies";
		int minRev = 0, maxRev = 3000, maxPairs = 20, numOfPairs = 0;
		
		File dir = new File(path);
		for (File sub : dir.listFiles()) {
			if (sub.isDirectory() && Character.isDigit(sub.getName().charAt(0))) {
				int rev = Integer.parseInt(sub.getName());
				if (rev >= minRev && rev <= maxRev) {
					File[] files = sub.listFiles();
					Arrays.sort(files);
					HashSet<String> dupPairs = new HashSet<String>();
					for(File file : files)
					{
						if(!dupPairs.contains(file.getName()))
						{
							String[] pairs = file.getName().split("_");
							dupPairs.add(pairs[1] + "_" + pairs[0]);
							System.out.println("\t\t" + file.getName());
						}
					}
					if (dupPairs.size() <= maxPairs)
						numOfPairs += dupPairs.size();
					else
						System.out.println("Revision " + rev + ": " + "has too many pairs!");
				}
			}
		}
		System.out.println("Total in range from " + minRev + " to " + maxRev + ": " + numOfPairs);
	}
}
