/**
 * 
 */
package report;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * @author Hoan Nguyen
 *
 */
public class DifPathFixer {
	private static String diffPath;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		System.out.println("Usage: java -jar DiffPathFixer.jar DiffPath ReportDir");
		
		if(args.length == 0)
			return;
		File fileDiffPath = new File(args[0]);
		diffPath = fileDiffPath.getAbsolutePath();
		File reportDir = new File(".");
		if(args.length == 2)
			reportDir = new File(args[1]);
		if(args.length > 2)
		{
			System.out.println("Too many parameters");
			return;
		}
		fixPath(reportDir);
	}
	private static void fixPath(File file)
	{
		if(file.isDirectory())
			for(File sub : file.listFiles())
				fixPath(sub);
		else if(file.getName().equals("diff.bat"))
		{
			try {
				BufferedWriter out = new BufferedWriter(new FileWriter(file));
				out.append("\"" + diffPath + "\" 1.txt 2.txt");
				out.flush();
				out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
