package report;

import java.io.File;
import java.util.Arrays;
import java.util.HashSet;

import util.FileIO;

public class GetInconsistencies {
	public static void main(String[] args) {
		String inPath = "D:\\projects\\JSync\\changes\\jfreechart_30_locations_1_2272\\inconsistencies";
		String outPath = "D:\\projects\\JSync\\changes\\out\\jfreechart";
		int minRev = 0, maxRev = 3000, maxPairs = 20, numOfPairs = 0;
		File inDir = new File(inPath), outDir = new File(outPath);
		for (File sub : inDir.listFiles()) {
			if (sub.isDirectory() && Character.isDigit(sub.getName().charAt(0))) {
				int rev = Integer.parseInt(sub.getName());
				if (rev >= minRev && rev <= maxRev) {
					File[] files = sub.listFiles();
					Arrays.sort(files);
					HashSet<String> dupPairs = new HashSet<String>();
					for(File file : files)
					{
						if(!dupPairs.contains(file.getName()))
						{
							String[] pairs = file.getName().split("_");
							dupPairs.add(pairs[1] + "_" + pairs[0]);
							System.out.println("\t\t" + file.getName());
						}
					}
					if (dupPairs.size() <= maxPairs) {
						numOfPairs += dupPairs.size();
						for (String p : dupPairs) {
							String[] parts = p.split("_");
							String name = parts[1] + "_" + parts[0];
							File pDir = new File(sub.getAbsolutePath() + "\\" + name);
							File tDir = new File(outPath + "\\" + sub.getName() + "_" + name);
							if(!tDir.exists())
								tDir.mkdirs();
							FileIO.writeStringToFile(FileIO.readStringFromFile(pDir.getAbsolutePath() + "\\" + parts[0] + "_old.java"), 
									tDir.getAbsolutePath() + "\\" + parts[0] + "_old.java");
							FileIO.writeStringToFile(FileIO.readStringFromFile(pDir.getAbsolutePath() + "\\" + parts[1] + "_old.java"), 
									tDir.getAbsolutePath() + "\\" + parts[1] + "_old.java");
							FileIO.writeStringToFile(FileIO.readStringFromFile(pDir.getAbsolutePath() + "\\" + parts[0] + "_new.java"), 
									tDir.getAbsolutePath() + "\\" + parts[0] + "_new.java");
							FileIO.writeStringToFile(FileIO.readStringFromFile(pDir.getAbsolutePath() + "\\" + parts[1] + "_new.java"), 
									tDir.getAbsolutePath() + "\\" + parts[1] + "_new.java");
							
						}
					}
					else
						System.out.println("Revision " + rev + ": " + "has too many pairs!");
				}
			}
		}
		System.out.println("Total in range from " + minRev + " to " + maxRev + ": " + numOfPairs);
	}
}
