/**
 * 
 */
package report;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Random;

import cleman.Util;

/**
 * @author Hoan Nguyen
 *
 */
public class MergeReport {
	private static ArrayList<String> merge = new ArrayList<String>(), shuffle = new ArrayList<String>();
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ArrayList<String> appDirs = new ArrayList<String>();
		appDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\netbeans-javadoc");
		//appDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\eclipse-ant");
		appDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\eclipse-jdtcore");
		appDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\j2sdk1.4.0-javax-swing");
		
		for(String appDir : appDirs)
		{
			merge = new ArrayList<String>();
			shuffle = new ArrayList<String>();
			getReports(new File(appDir + "\\clonesCleman2Check"));
			getReports(new File(appDir + "\\clonesCCF2Check"));
			getReports(new File(appDir + "\\clonesDeckard2Check"));
			Random random = new Random();
			while (!merge.isEmpty())
			{
				int index = random.nextInt(merge.size());
				shuffle.add(merge.get(index));
				merge.remove(index);
			}
			try {
				BufferedWriter out = new BufferedWriter(new FileWriter(appDir + "\\mergeIndex.txt"));
				for(int i = 0; i < shuffle.size(); i++)
					out.append(shuffle.get(i) + "\r\n");
				out.flush();
				out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			File reportDir = new File(appDir + "\\clones2Check");
			if(!reportDir.exists())
				reportDir.mkdirs();
			for(int i = 0; i < shuffle.size(); i++)
			{
				copyDir(new File(appDir + "\\" + shuffle.get(i)), new File(reportDir.getAbsolutePath() + "\\" + i));
			}
		}
	}
	private static void copyDir(File fromDir, File toDir)
	{
		if(!toDir.exists())
			toDir.mkdirs();
		System.err.println(fromDir.getAbsolutePath());
		for(File file : fromDir.listFiles())
			if(file.isFile())
			{
				try {
					BufferedWriter out = new BufferedWriter(new FileWriter(toDir + "\\" + file.getName()));
					out.append(Util.getFileContent(file));
					out.flush();
					out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
	}
	private static void getReports(File dir)
	{
		System.err.println(dir.getAbsolutePath());
		int max = dir.listFiles().length;
		Random rand = new Random();
		HashSet<Integer> samples = new HashSet<Integer>();
		for(int i = 0; i < 100; i++)
		{
			int sample = rand.nextInt(max);
			while (samples.contains(sample))
				sample = rand.nextInt(max);
			samples.add(sample);
			File sub = dir.listFiles()[sample];
			merge.add(dir.getName() + "\\" + sub.getName());
		}
	}

}
