package report;

import java.io.File;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Random;

import util.FileIO;

public class SplitInconsistencies {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String path = "D:\\TA\\CprE416\\assignment1\\jfreechart-pairs";
		File dir = new File(path), outDir = new File(path + "\\..\\lists");
		if (!outDir.exists())
			outDir.mkdir();
		ArrayList<String> names = new ArrayList<String>();
		for (File sub : dir.listFiles()) {
			if (sub.isDirectory() && Character.isDigit(sub.getName().charAt(0)))
			names.add(sub.getName());
		}
		HashSet<String> sampledNames = new HashSet<String>();
		int n = 30, size = 15;
		Random r = new Random();
		for (int i = 0; i < n; i++) {
			StringBuilder sb = new StringBuilder();
			ArrayList<String> tmpNames = new ArrayList<String>(names);
			HashSet<Integer> sampledNumbers = new HashSet<Integer>();
			for (int j = 0; j < size; j++) {
				while (true) {
					int s = r.nextInt(tmpNames.size());
					if (!sampledNumbers.contains(s)) {
						sampledNumbers.add(s);
						sb.append(tmpNames.get(s) + "\r\n");
						sampledNames.add(tmpNames.get(s));
						break;
					}
				}
			}
			FileIO.writeStringToFile(sb.toString(), outDir.getAbsolutePath() + "\\" + (i+1) + ".txt");
		}
		System.out.println("Sampled: " + sampledNames.size() + "/" + names.size());
	}

}
