/**
 * 
 */
package report;

import java.io.File;
import java.util.ArrayList;

import org.tmatesoft.svn.core.SVNException;
import org.tmatesoft.svn.core.SVNURL;
import org.tmatesoft.svn.core.auth.ISVNAuthenticationManager;
import org.tmatesoft.svn.core.internal.io.dav.DAVRepositoryFactory;
import org.tmatesoft.svn.core.io.SVNRepository;
import org.tmatesoft.svn.core.io.SVNRepositoryFactory;
import org.tmatesoft.svn.core.wc.SVNWCUtil;

import cleman.Util;

/**
 * @author Hoan Nguyen
 *
 */
public class TestCountLOC {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		countLocal();
	}
	
	private static void countLocal(){
		ArrayList<String> srcDirs = new ArrayList<String>();
//		srcDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\netbeans-javadoc");
//		srcDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\eclipse-ant");
//		srcDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\eclipse-jdtcore");
//		srcDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\j2sdk1.4.0-javax-swing");
//		srcDirs.add("D:\\Iowa State Uni\\Projects\\Subject systems\\eu.geclipse");
		srcDirs.add("C:\\projects\\jboss-6.0.0.Final-src");
		for(String srcDir : srcDirs)
			System.out.println(srcDir + ": " + Util.countLOC(new File(srcDir), "java"));
	}
	
	private static void countSVN() {
		String svnURL = "https://seg-pc1.dnsalias.net:8443/svn/", projectName = "argouml", trunkDir = "trunk";
		//String svnURL = "https://seg-pc1.dnsalias.net:8443/svn/", projectName = "eu.geclipse", trunkDir = "trunk";
		SVNURL projectSVNURL;
		String repUserName = "hoan", repPassword = "dobietday";
		ISVNAuthenticationManager authManager;
		SVNRepository repository = null;
		DAVRepositoryFactory.setup();
		try {
			projectSVNURL = SVNURL.parseURIEncoded(svnURL + "/" + projectName + "/" + trunkDir);
			authManager = SVNWCUtil.createDefaultAuthenticationManager(repUserName, repPassword);
			repository = SVNRepositoryFactory.create(projectSVNURL);
			repository.setAuthenticationManager(authManager);
			repository.testConnection();
		} catch (SVNException e) {
			e.printStackTrace();
		}
		long startRevision = 3000, endRevision = 4000;
		int step = 1;
		for(long rev = startRevision; rev <= endRevision; rev += step)
		{
			int[] count = Util.countLOC(repository, "", rev);
			System.out.println("Revision " + rev + ": " + count[0] + " files " + count[1] + " LOC");
		}
	}
}
