/**
 * 
 */
package treeMapping;

import java.util.ArrayList;

/**
 * @author Nguyen Anh Hoan
 *
 */
public class ChangedFile {
	private String fileName = null;
	private String fileContent = null;
	private ArrayList<Integer> deletedLines;
	private ArrayList<Integer> addedLines;
	
	/**
	 * 
	 */
	public ChangedFile()
	{
		
	}
	/**
	 * 
	 */
	public ChangedFile(String fileName)
	{
		this.fileName = fileName;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		return fileName.hashCode();
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ChangedFile other = (ChangedFile) obj;
		if (fileName == null) {
			if (other.fileName != null)
				return false;
		} else if (!fileName.equals(other.fileName))
			return false;
		return true;
	}
	/**
	 * 
	 */
	/**
	 * @return the fileName
	 */
	public String getFileName() {
		return fileName;
	}
	/**
	 * @param fileName the fileName to set
	 */
	public void setFileName(String fileName) {
		this.fileName = fileName;
	}
	/**
	 * @return the deletedLines
	 */
	public ArrayList<Integer> getDeletedLines() {
		return deletedLines;
	}
	/**
	 * @param deletedLines the deletedLines to set
	 */
	public void setDeletedLines(ArrayList<Integer> deletedLines) {
		this.deletedLines = deletedLines;
	}
	/**
	 * @return the addedLines
	 */
	public ArrayList<Integer> getAddedLines() {
		return addedLines;
	}
	/**
	 * @param addedLines the addedLines to set
	 */
	public void setAddedLines(ArrayList<Integer> addedLines) {
		this.addedLines = addedLines;
	}
	/**
	 * @return the fileContent
	 */
	public String getFileContent() {
		return fileContent;
	}
	/**
	 * @param fileContent the fileContent to set
	 */
	public void setFileContent(String fileContent) {
		this.fileContent = fileContent;
	}
	public String toString()
	{
		StringBuffer buff = new StringBuffer();
		buff.append("File: " + this.fileName + "\r\n");
		buff.append("Deleted lines in old revision\r\n");
		for(int i = 0; i < this.deletedLines.size(); i++)
			buff.append(this.deletedLines.get(i) + " ");
		buff.append("\r\n");
		buff.append("Added lines in new revision\r\n");
		for(int i = 0; i < addedLines.size(); i++)
			buff.append(addedLines.get(i) + " ");
		buff.append("\r\n");
		
		return buff.toString();
	}
}
