/**
 * 
 */
package treeMapping;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Random;

import org.eclipse.jdt.core.dom.ASTNode;

import CloneTransforming.ASTNodeWrapper;
import CloneTransforming.CloneSync;
import cleman.Util;

import repositoryConnecting.SVNConnector;
import util.FileIO;

/**
 * @author Hoan Anh Nguyen
 *
 */
public class TestTreeMapping {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		/*String src1 = CloneSync.getFileContent(new File("input/M.java"))[1], src2 = CloneSync.getFileContent(new File("input/N.java"))[1];
		ASTNode ast1M = ASTNodeWrapper.createAST(src1);
		ASTNode ast2M = ASTNodeWrapper.createAST(src2);*/
		String src1 = FileIO.readStringFromFile("input/M.java"), src2 = FileIO.readStringFromFile("input/N.java");
		MapSourceFile file1M = new MapSourceFile(src1);
		MapSourceFile file2M = new MapSourceFile(src2);
		file1M.buildBlockCommentLines();
		file2M.buildBlockCommentLines();
		
		LineDiff lineDiff = new LineDiff(file1M, file2M);
		ArrayList<ArrayList<Integer>> diff = lineDiff.doDiff();
		file1M.setUnchangedLines(diff.get(0));
		file2M.setUnchangedLines(diff.get(1));
		TreeMapper mapper = new TreeMapper(file1M, file2M);
		mapper.map();
		
		/*String url = "https://129.186.158.195:8443/svn/projects/CFGProject/workspace/CFG";
		long r1 = 264, r2 = 265;*/
		/*String url = "https://129.186.158.195:8443/svn/jedit/jEdit/trunk";
		int startRevision = 3000, endRevision = 14000;*/
		/*String url = "https://129.186.158.195:8443/svn/eu.geclipse/trunk";
		int startRevision = 6138, endRevision = 15054;
		int currentRevision = startRevision+1, previousRevision = startRevision;
		Random rand = new Random();
		ArrayList<Integer> pool = new ArrayList<Integer>();
		for(int i = startRevision; i <= endRevision; i++)
			pool.add(i);
		int i = 0;
		PrintStream ps = System.out;
		while(i < 200)
		{
			int j = rand.nextInt(pool.size());
			previousRevision = pool.get(j);
			pool.remove(j);
			currentRevision = previousRevision + 1;
			
			SVNConnector svnConnector = new SVNConnector(url, "hoan", "dobietday");
			if(!svnConnector.connect())
				currentRevision++;
			if(currentRevision > endRevision)
				break;
			System.err.println("Revision: " + currentRevision);
			File logFile = null;
			try{
				logFile = new File("_log_TreeMapping_" + previousRevision+ "_" + currentRevision + ".txt");
				System.setOut(new PrintStream(logFile));
			}
			catch (IOException e){
				e.printStackTrace();
			}
			long startTime = System.currentTimeMillis();
			long r1 = previousRevision, r2 = currentRevision;
			//long r1 = 3802, r2 = 3803;
			String url = "https://129.186.100.197:8443/svn/projects/test";
			long r1 = 38, r2 = 41;

			long endTime = System.currentTimeMillis();
			System.out.println("Connected: " + (endTime - startTime)/1000.000 + "s");
			String diff = svnConnector.getDiff(r1, r2);
			Locater locater = new Locater(diff);
			ArrayList<ChangedFile> changedFiles = locater.locate();
			endTime = System.currentTimeMillis();
			System.out.println("Located: " + (endTime - startTime)/1000.000 + "s");
			if(changedFiles.isEmpty())
			{
				System.out.println("No changes");
				System.out.flush();
				System.setOut(ps);
				if(logFile.exists())
					logFile.deleteOnExit();
				continue;
			}
			boolean hasChanges = false;
			for(ChangedFile changedFile : changedFiles)
			{
				if(!svnConnector.checkExistence(changedFile.getFileName(), r1))
				{
					System.out.println("This file was newly added: " + changedFile.getFileName() + "\n");
					continue;
				}
				else if(!svnConnector.checkExistence(changedFile.getFileName(), r2))
				{
					System.out.println("This file was deleted: " + changedFile.getFileName() + "\n");
					continue;
				}
				System.out.println("Start mapping " + changedFile.getFileName());
				hasChanges = true;
				MapSourceFile fileM = new MapSourceFile(svnConnector.getFile(changedFile.getFileName(), r1));
				fileM.setFilePath(changedFile.getFileName());
				fileM.setChangedLines(changedFile.getDeletedLines());
				fileM.buildBlockCommentLines();
				fileM.buildUnchangedLines();

				MapSourceFile fileN = new MapSourceFile(svnConnector.getFile(changedFile.getFileName(), r2));
				fileN.setFilePath(changedFile.getFileName());
				fileN.setChangedLines(changedFile.getAddedLines());
				fileN.buildBlockCommentLines();
				fileN.buildUnchangedLines();

				//System.out.println(changedFile);

				TreeMapper mapper = new TreeMapper(fileM, fileN);
				mapper.map();
				System.out.println("Finish mapping " + changedFile.getFileName());
				System.out.println();
			}
			endTime = System.currentTimeMillis();
			System.out.println((endTime - startTime)/1000.000 + "s");
			
			previousRevision = currentRevision++;
			System.out.flush();
			System.setOut(ps);
			if(hasChanges)
				i++;
			else
			{
				if(logFile.exists())
					logFile.deleteOnExit();
			}
		}*/
	}
}
