package treeMapping;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Stack;

import org.eclipse.jdt.core.dom.*;

/**
 * @author Nguyen Anh Hoan
 *
 */
class Visitor extends ASTVisitor {
	public static byte[] indexer = new byte[84];	//category of this node type (Class, Method, Block, Statement, ..)
	//public ArrayList<Integer> lines = new ArrayList<Integer>();
	MapSourceFile sourceFile;
	String fileName;
	String className;
	
	int indent = 0;
    //public ArrayList<Fragment> fragments = new ArrayList<Fragment>();	//fragments of one file
    /*
	 * Stack of children's n-gram vectors
	 */
	Stack<ArrayList<HashMap<Integer, Integer>>> stackChildrenVectors = new Stack<ArrayList<HashMap<Integer, Integer>>>();
	/*
	 * Stack of VERTICAL n-grams starting from the ROOT of the subtrees 
	 */
	Stack<ArrayList<HashMap<Integer, Integer>>> stackChildrenRootVGrams = new Stack<ArrayList<HashMap<Integer, Integer>>>();
	/*
	 * Stack of HORIZONTAL sequences of children
	 */
	Stack<ArrayList<Byte>> stackChildrenHSequences = new Stack<ArrayList<Byte>>();
	
	//Stack<HashSet<Fragment>> stackChildrenFragments = new Stack<HashSet<Fragment>>();
    
	int lastNode = 0;	//for end token of vector
    Stack<Integer> stackCurrentNode = new Stack<Integer>();	//for start token of vector

    public Visitor() {

    }
    public Visitor(String fileName) {
    	this.fileName = fileName;
    }
    public Visitor(MapSourceFile sourceFile) {
    	this.sourceFile = sourceFile;
    }
    public void preVisit(ASTNode node) {
    	int aNode = node.getNodeType(); 
    	if (aNode == ASTNode.JAVADOC || aNode == ASTNode.BLOCK_COMMENT || aNode == ASTNode.LINE_COMMENT)
    	{
    		return;
    	}
    	/*if(aNode == ASTNode.COMPILATION_UNIT)
    	{
    		System.out.println(node.toString());
    	}*/
    	stackCurrentNode.push(++lastNode); 
    	for(int i = 0; i < indent; i++)
    		System.out.print("\t");
    	String nodeType = node.getClass().getSimpleName();
    	System.out.println(nodeType + " { " + ((node.getNodeType() == ASTNode.SIMPLE_NAME) ? node.toString() : ""));
    	indent++;
    }
    public void postVisit(ASTNode node) {
    	int aNode = node.getNodeType();
    	if (aNode == ASTNode.JAVADOC || aNode == ASTNode.BLOCK_COMMENT || aNode == ASTNode.LINE_COMMENT)
    		return;
    	
    	indent--;
    	for(int i = 0; i < indent; i++)
    		System.out.print("\t");
    	System.out.println("}");
    }
    public boolean visit(IfStatement node)
    {
    	
    	return true;
    }
 }
