package util;

import java.util.ArrayList;

public class StringProcessor {
	public static void main(String[] args) {
		System.out.println(serialize2("Set"));
	}
	
	public ArrayList<Integer> match(String str, String target)
	{
		return match(serialize2(str), serialize2(target));
	}
	public static ArrayList<Integer> match(ArrayList<String> str, ArrayList<String> target)
	{
		int lenM = str.size(), lenN = target.size();
		int[][] d = new int[lenM+1][lenN+1];
		String[] codeM = new String[lenM+1];
		String[] codeN = new String[lenN+1];
		String[][] p = new String[lenM+1][lenN+1];
		d[0][0] = 0;
		for(int i = 1; i <= lenM; i++)
		{
			d[i][0] = 0;
			codeM[i] = str.get(i-1);
		}
		for(int i = 1; i <= lenN; i++)
		{
			d[0][i] = 0;
			codeN[i] = target.get(i-1);
		}
		for(int i = 1; i <= lenM; i++)
		{
			for(int j = 1; j <= lenN; j++)
			{
				if(codeM[i].equals(codeN[j]))
				{
					d[i][j] = d[i-1][j-1] + 1;
					p[i][j] = "LU";
				}
				else if(d[i-1][j] >= d[i][j-1])
				{
					d[i][j] = d[i-1][j];
					p[i][j] = "U";
				}
				else
				{
					d[i][j] = d[i][j-1];
					p[i][j] = "L";
				}
			}
		}
		ArrayList<Integer> lcsM = new ArrayList<Integer>();
		ArrayList<Integer> lcsN = new ArrayList<Integer>();
		printLCS(p, lenM, lenN, lcsM, lcsN);
		
		ArrayList<Integer> pos = new ArrayList<Integer>();
		int preM = -1, preN = -1;
		for(int i = 0; i < lcsM.size(); i++)
		{
			preM++; preN++;
			int m = lcsM.get(i), n = lcsN.get(i);
			while(preN < n)
			{
				if(preM < m)
				{
					pos.add(preM);
					preM++;
				}
				else
					pos.add(-1);
				preN++;
			}
			pos.add(m);
		}
		preM++; preN++;
		while(preN < lenN)
		{
			if(preM < lenM)
			{
				pos.add(preM);
				preM++;
			}
			else
				pos.add(-1);
			preN++;
		}
		
		return pos;
	}
	private static void printLCS(String[][] p, int lenM, int lenN, ArrayList<Integer> lcsM, ArrayList<Integer> lcsN)
	{
		int i = lenM, j = lenN;
		while(i > 0 && j > 0)
		{
			if(p[i][j].equals("LU"))
			{
				lcsM.add(0, i-1);
				lcsN.add(0, j-1);
				i--; j--;
			}
			else if(p[i][j].equals("U"))
				i--;
			else
				j--;
		}
	}
	public static ArrayList<String> serialize(String text)
	{
		ArrayList<String> list = new ArrayList<String>();
		int start = 0;
		while(start < text.length())
		{
			String word = "";
			while(start < text.length() && !Character.isLetterOrDigit(text.charAt(start)))
				start++;
			if(start < text.length())
			{
				int end = start;
				if(Character.isDigit(text.charAt(start)))
				{
					while(end+1 < text.length() && Character.isDigit(text.charAt(end+1)))
						end++;
				}
				else if(Character.isLowerCase(text.charAt(start)))
				{
					while(end+1 < text.length() && Character.isLowerCase(text.charAt(end+1)))
						end++;
				}
				else if(Character.isUpperCase(text.charAt(start)))
				{
					if(end+1 < text.length())
					{
						char ch = text.charAt(end+1);
						if(Character.isUpperCase(ch))
						{
							end++;
							while(end+1 < text.length() && Character.isUpperCase(text.charAt(end+1)))
								end++;
							if(end+1 < text.length() && Character.isLowerCase(text.charAt(end+1)))
								end--;
						}
						else if(Character.isLowerCase(ch))
						{
							end++;
							while(end+1 < text.length() && Character.isLowerCase(text.charAt(end+1)))
								end++;
						}
					}
				}
				else
				{
					System.out.println("What should be else???");
				}
				word = text.substring(start, end+1);
				start = end + 1;
			}
			list.add(word.toLowerCase());
		}
		
		return list;
	}
	public static ArrayList<String> serialize2(String text)
	{
		ArrayList<String> list = new ArrayList<String>();
		int start = 0;
		while(start < text.length())
		{
			String word = "";
			while(start < text.length() && !Character.isLetterOrDigit(text.charAt(start)))
			{
				word += text.charAt(start);
				start++;
			}
			if (!word.isEmpty())
			{
				list.add(word);
				word = "";
			}
			if(start < text.length())
			{
				int end = start;
				if(Character.isDigit(text.charAt(start)))
				{
					while(end+1 < text.length() && Character.isDigit(text.charAt(end+1)))
						end++;
				}
				else if(Character.isLowerCase(text.charAt(start)))
				{
					while(end+1 < text.length() && Character.isLowerCase(text.charAt(end+1)))
						end++;
				}
				else if(Character.isUpperCase(text.charAt(start)))
				{
					if(end+1 < text.length())
					{
						char ch = text.charAt(end+1);
						if(Character.isUpperCase(ch))
						{
							end++;
							while(end+1 < text.length() && Character.isUpperCase(text.charAt(end+1)))
								end++;
							if(end+1 < text.length() && Character.isLowerCase(text.charAt(end+1)))
								end--;
						}
						else if(Character.isLowerCase(ch))
						{
							end++;
							while(end+1 < text.length() && Character.isLowerCase(text.charAt(end+1)))
								end++;
						}
					}
				}
				else
				{
					System.out.println("What should be else???");
				}
				word = text.substring(start, end+1);
				start = end + 1;
			}
			list.add(word);
		}
		
		return list;
	}
	
	public static String getToken(String source, String target)
	{
		char ch = source.charAt(0);
		if(!Character.isLetter(ch) || Character.isLowerCase(ch))
			return target;
		if(source.length() == 1 || Character.isUpperCase(source.charAt(1)))
			return target.toUpperCase();
		return target.substring(0, 1).toUpperCase() + target.substring(1);
	}
	
	public static void doLCS(ArrayList<String> term1, ArrayList<String> term2, int neighborhood, ArrayList<Integer> lcsM, ArrayList<Integer> lcsN)
	{
		ArrayList<Integer> matchesM = new ArrayList<Integer>();
		for (int i = 0; i < term1.size(); i++)
			matchesM.add(-1);
		ArrayList<Integer> matchesN = new ArrayList<Integer>();
		for (int i = 0; i < term2.size(); i++)
			matchesN.add(-1);
		doLCS(term1, term2, 0, term1.size()-1, 0, term2.size()-1, neighborhood, matchesM, matchesN);
		for (int i = 0; i < matchesM.size(); i++)
		{
			int j = matchesM.get(i);
			if (j > -1)
			{
				lcsM.add(i);
				lcsN.add(j);
			}
		}
	}
	
	/**
	 * Largest Common Sub-sequence
	 * @param term1
	 * @param term2
	 * @param neighborhood
	 * @param lcsM
	 * @param lcsN
	 * @param startM
	 * @param endM
	 * @param startN
	 * @param endN
	 */
	public static void doLCS(ArrayList<String> term1, ArrayList<String> term2, int startM, int endM, int startN, int endN, int neighborhood, ArrayList<Integer> lcsM, ArrayList<Integer> lcsN)
	{
		int lenM = endM - startM + 1, lenN = endN - startN + 1;
		int[][] d = new int[lenM+1][lenN+1];
		String[] codeM = new String[lenM+1];
		String[] codeN = new String[lenN+1];
		String[][] p = new String[lenM+1][lenN+1];
		d[0][0] = 0;
		for(int i = 1; i <= lenM; i++)
		{
			d[i][0] = 0;
			codeM[i] = term1.get(startM+i-1);
		}
		for(int i = 1; i <= lenN; i++)
		{
			d[0][i] = 0;
			codeN[i] = term2.get(startN+i-1);
		}
		ArrayList<String> iNeighbors = new ArrayList<String>();
		for (int i = 0; i < neighborhood+1; i++)
		{
			if (startM-1+i < term1.size() && startM-1+i >= neighborhood)
			{
				StringBuffer buf = new StringBuffer();
				for (int l = 0; l < neighborhood+1; l++)
					buf.append(term1.get(startM-1+i-neighborhood+l) + " ");
				iNeighbors.add(buf.toString());
			}
			else
				iNeighbors.add("");
		}
		for(int i = 1; i <= lenM; i++)
		{
			if (neighborhood > 0)
			{
				iNeighbors.remove(0);
				if (lenM-i >= neighborhood)
				{
					String pre = iNeighbors.get(neighborhood-1);
					//if (pre.equals(""))
					if (startM+i-1+neighborhood < term1.size())
					{
						StringBuffer buf = new StringBuffer();
						for (int k = i; k <= i+neighborhood; k++)
							//buf.append(codeM[k] + " ");
							buf.append(term1.get(startM+k-1) + " ");
						iNeighbors.add(buf.toString());
					}
					else
						//iNeighbors.add(pre.substring(codeM[i-1].length()+1) + codeM[i+neighborhood] + " ");
						iNeighbors.add(pre.substring(term1.get(startM+i-2).length()+1) + term1.get(startM+i-1+neighborhood) + " ");
				}
				else
					iNeighbors.add("");
			}
			ArrayList<String> jNeighbors = new ArrayList<String>();
			for (int k = 0; k < neighborhood+1; k++)
			{
				if (startN-1+k < term2.size() && startN-1+k >= neighborhood)
				{
					StringBuffer buf = new StringBuffer();
					for (int l = 0; l < neighborhood+1; l++)
						buf.append(term2.get(startN-1+k-neighborhood+l) + " ");
					jNeighbors.add(buf.toString());
				}
				else
					jNeighbors.add("");
			}
			for(int j = 1; j <= lenN; j++)
			{
				if (neighborhood > 0)
				{
					jNeighbors.remove(0);
					//if (lenN-j >= neighborhood)
					if (startN+j-1+neighborhood < term2.size())
					{
						String pre = jNeighbors.get(neighborhood-1);
						if (pre.equals(""))
						{
							StringBuffer buf = new StringBuffer();
							for (int k = j; k <= j+neighborhood; k++)
								//buf.append(codeN[k] + " ");
								buf.append(term2.get(startN+k-1) + " ");
							jNeighbors.add(buf.toString());
						}
						else
						{
							//if (codeN[j-1].length() < 0)
							if (term2.get(startN+j-2).length() < 0)
								System.err.println("WTF");
							//jNeighbors.add(pre.substring(codeN[j-1].length()+1) + codeN[j+neighborhood] + " ");
							jNeighbors.add(pre.substring(term2.get(startN+j-2).length()+1) + term2.get(startN+j-1+neighborhood) + " ");
						}
					}
					else
						jNeighbors.add("");
				}
				boolean isMatched = false;
				if (codeM[i].equals(codeN[j]))
				{
					if (neighborhood == 0)
						isMatched = true;
					else 
						for (int k = 0; k < neighborhood+1; k++)
							if (!iNeighbors.get(k).equals("") && iNeighbors.get(k).equals(jNeighbors.get(k)))
							{
								isMatched = true;
								break;
							}
				}
				if(isMatched)
				{
					d[i][j] = d[i-1][j-1] + 1;
					p[i][j] = "LU";
				}
				else if(d[i-1][j] >= d[i][j-1])
				{
					d[i][j] = d[i-1][j];
					p[i][j] = "U";
				}
				else
				{
					d[i][j] = d[i][j-1];
					p[i][j] = "L";
				}
			}
		}
		int i = lenM, j = lenN;
		int preM = lenM+1, preN = lenN+1;
		while(i > 0 && j > 0)
		{
			if(p[i][j].equals("LU"))
			{
				lcsM.set(startM+i-1, startN+j-1);
				lcsN.set(startN+j-1, startM+i-1);
				if (neighborhood > 0)
				{
					if (i < preM-1 && j < preN-1)
						doLCS(term1, term2, startM+i, startM+preM-2, startN+j, startN+preN-2, (neighborhood-1)/2, lcsM, lcsN);
					preM = i; preN = j;
				}	
				i--; j--;
			}
			else if(p[i][j].equals("U"))
				i--;
			else
				j--;
		}
		if (neighborhood > 0 && preM > 1 && preN > 1)
			doLCS(term1, term2, startM, startM+preM-2, startN, startN+preN-2, (neighborhood-1)/2, lcsM, lcsN);
	}
}
